// Automatically generated by 'openshift-apidocs-gen'. Do not edit.
:_mod-docs-content-type: ASSEMBLY
[id="api-object-reference"]
= Common object reference
:toc: macro
:toc-title:

toc::[]

[id="io.k8s.api.admissionregistration.v1.MutatingWebhookConfigurationList"]
== io.k8s.api.admissionregistration.v1.MutatingWebhookConfigurationList schema


Description::
+
--
MutatingWebhookConfigurationList is a list of MutatingWebhookConfiguration.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../webhook_apis/mutatingwebhookconfiguration-admissionregistration-k8s-io-v1.adoc#mutatingwebhookconfiguration-admissionregistration-k8s-io-v1[`array (MutatingWebhookConfiguration)`]
| List of MutatingWebhookConfiguration.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.admissionregistration.v1.ValidatingWebhookConfigurationList"]
== io.k8s.api.admissionregistration.v1.ValidatingWebhookConfigurationList schema


Description::
+
--
ValidatingWebhookConfigurationList is a list of ValidatingWebhookConfiguration.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../webhook_apis/validatingwebhookconfiguration-admissionregistration-k8s-io-v1.adoc#validatingwebhookconfiguration-admissionregistration-k8s-io-v1[`array (ValidatingWebhookConfiguration)`]
| List of ValidatingWebhookConfiguration.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.apps.v1.ControllerRevisionList"]
== io.k8s.api.apps.v1.ControllerRevisionList schema


Description::
+
--
ControllerRevisionList is a resource containing a list of ControllerRevision objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../apps_apis/controllerrevision-apps-v1.adoc#controllerrevision-apps-v1[`array (ControllerRevision)`]
| Items is the list of ControllerRevisions

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.apps.v1.DaemonSetList"]
== io.k8s.api.apps.v1.DaemonSetList schema


Description::
+
--
DaemonSetList is a collection of daemon sets.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../apps_apis/daemonset-apps-v1.adoc#daemonset-apps-v1[`array (DaemonSet)`]
| A list of daemon sets.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.apps.v1.DeploymentList"]
== io.k8s.api.apps.v1.DeploymentList schema


Description::
+
--
DeploymentList is a list of Deployments.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../apps_apis/deployment-apps-v1.adoc#deployment-apps-v1[`array (Deployment)`]
| Items is the list of Deployments.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata.

|===

[id="io.k8s.api.apps.v1.ReplicaSetList"]
== io.k8s.api.apps.v1.ReplicaSetList schema


Description::
+
--
ReplicaSetList is a collection of ReplicaSets.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../apps_apis/replicaset-apps-v1.adoc#replicaset-apps-v1[`array (ReplicaSet)`]
| List of ReplicaSets. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.apps.v1.StatefulSetList"]
== io.k8s.api.apps.v1.StatefulSetList schema


Description::
+
--
StatefulSetList is a collection of StatefulSets.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../apps_apis/statefulset-apps-v1.adoc#statefulset-apps-v1[`array (StatefulSet)`]
| Items is the list of stateful sets.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.autoscaling.v2.HorizontalPodAutoscalerList"]
== io.k8s.api.autoscaling.v2.HorizontalPodAutoscalerList schema


Description::
+
--
HorizontalPodAutoscalerList is a list of horizontal pod autoscaler objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../autoscaling_apis/horizontalpodautoscaler-autoscaling-v2.adoc#horizontalpodautoscaler-autoscaling-v2[`array (HorizontalPodAutoscaler)`]
| items is the list of horizontal pod autoscaler objects.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| metadata is the standard list metadata.

|===

[id="io.k8s.api.batch.v1.CronJobList"]
== io.k8s.api.batch.v1.CronJobList schema


Description::
+
--
CronJobList is a collection of cron jobs.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../batch_apis/cronjob-batch-v1.adoc#cronjob-batch-v1[`array (CronJob)`]
| items is the list of CronJobs.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.batch.v1.JobList"]
== io.k8s.api.batch.v1.JobList schema


Description::
+
--
JobList is a collection of jobs.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../batch_apis/job-batch-v1.adoc#job-batch-v1[`array (Job)`]
| items is the list of Jobs.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.certificates.v1.CertificateSigningRequestList"]
== io.k8s.api.certificates.v1.CertificateSigningRequestList schema


Description::
+
--
CertificateSigningRequestList is a collection of CertificateSigningRequest objects
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../certificates_apis/certificatesigningrequest-certificates-k8s-io-v1.adoc#certificatesigningrequest-certificates-k8s-io-v1[`array (CertificateSigningRequest)`]
| items is a collection of CertificateSigningRequest objects

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
|

|===

[id="io.k8s.api.coordination.v1.LeaseList"]
== io.k8s.api.coordination.v1.LeaseList schema


Description::
+
--
LeaseList is a list of Lease objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../coordination_apis/lease-coordination-k8s-io-v1.adoc#lease-coordination-k8s-io-v1[`array (Lease)`]
| items is a list of schema objects.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.core.v1.Affinity"]
== io.k8s.api.core.v1.Affinity schema


Description::
+
--
Affinity is a group of affinity scheduling rules.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `nodeAffinity`
| xref:../objects/index.adoc#io.k8s.api.core.v1.NodeAffinity[`NodeAffinity`]
| Describes node affinity scheduling rules for the pod.

| `podAffinity`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodAffinity[`PodAffinity`]
| Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)).

| `podAntiAffinity`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodAntiAffinity[`PodAntiAffinity`]
| Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)).

|===

[id="io.k8s.api.core.v1.AWSElasticBlockStoreVolumeSource"]
== io.k8s.api.core.v1.AWSElasticBlockStoreVolumeSource schema


Description::
+
--
Represents a Persistent Disk resource in AWS.

An AWS EBS disk must exist before mounting to a container. The disk must also be in the same AWS zone as the kubelet. An AWS EBS disk can only be mounted as read/write once. AWS EBS volumes support ownership management and SELinux relabeling.
--

Type::
  `object`

Required::
  - `volumeID`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is the filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

| `partition`
| `integer`
| partition is the partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty).

| `readOnly`
| `boolean`
| readOnly value true will force the readOnly setting in VolumeMounts. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

| `volumeID`
| `string`
| volumeID is unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

|===

[id="io.k8s.api.core.v1.AzureDiskVolumeSource"]
== io.k8s.api.core.v1.AzureDiskVolumeSource schema


Description::
+
--
AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.
--

Type::
  `object`

Required::
  - `diskName`
  - `diskURI`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `cachingMode`
| `string`
| cachingMode is the Host Caching mode: None, Read Only, Read Write.

Possible enum values:
 - `"None"`
 - `"ReadOnly"`
 - `"ReadWrite"`

| `diskName`
| `string`
| diskName is the Name of the data disk in the blob storage

| `diskURI`
| `string`
| diskURI is the URI of data disk in the blob storage

| `fsType`
| `string`
| fsType is Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

| `kind`
| `string`
| kind expected values are Shared: multiple blob disks per storage account  Dedicated: single blob disk per storage account  Managed: azure managed data disk (only in managed availability set). defaults to shared

Possible enum values:
 - `"Dedicated"`
 - `"Managed"`
 - `"Shared"`

| `readOnly`
| `boolean`
| readOnly Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

|===

[id="io.k8s.api.core.v1.AzureFilePersistentVolumeSource"]
== io.k8s.api.core.v1.AzureFilePersistentVolumeSource schema


Description::
+
--
AzureFile represents an Azure File Service mount on the host and bind mount to the pod.
--

Type::
  `object`

Required::
  - `secretName`
  - `shareName`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `readOnly`
| `boolean`
| readOnly defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

| `secretName`
| `string`
| secretName is the name of secret that contains Azure Storage Account Name and Key

| `secretNamespace`
| `string`
| secretNamespace is the namespace of the secret that contains Azure Storage Account Name and Key default is the same as the Pod

| `shareName`
| `string`
| shareName is the azure Share Name

|===

[id="io.k8s.api.core.v1.AzureFileVolumeSource"]
== io.k8s.api.core.v1.AzureFileVolumeSource schema


Description::
+
--
AzureFile represents an Azure File Service mount on the host and bind mount to the pod.
--

Type::
  `object`

Required::
  - `secretName`
  - `shareName`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `readOnly`
| `boolean`
| readOnly defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

| `secretName`
| `string`
| secretName is the  name of secret that contains Azure Storage Account Name and Key

| `shareName`
| `string`
| shareName is the azure share Name

|===

[id="io.k8s.api.core.v1.Capabilities"]
== io.k8s.api.core.v1.Capabilities schema


Description::
+
--
Adds and removes POSIX capabilities from running containers.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `add`
| `array (string)`
| Added capabilities

| `drop`
| `array (string)`
| Removed capabilities

|===

[id="io.k8s.api.core.v1.CephFSPersistentVolumeSource"]
== io.k8s.api.core.v1.CephFSPersistentVolumeSource schema


Description::
+
--
Represents a Ceph Filesystem mount that lasts the lifetime of a pod Cephfs volumes do not support ownership management or SELinux relabeling.
--

Type::
  `object`

Required::
  - `monitors`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `monitors`
| `array (string)`
| monitors is Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

| `path`
| `string`
| path is Optional: Used as the mounted root, rather than the full Ceph tree, default is /

| `readOnly`
| `boolean`
| readOnly is Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

| `secretFile`
| `string`
| secretFile is Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretReference[`SecretReference`]
| secretRef is Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

| `user`
| `string`
| user is Optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

|===

[id="io.k8s.api.core.v1.CephFSVolumeSource"]
== io.k8s.api.core.v1.CephFSVolumeSource schema


Description::
+
--
Represents a Ceph Filesystem mount that lasts the lifetime of a pod Cephfs volumes do not support ownership management or SELinux relabeling.
--

Type::
  `object`

Required::
  - `monitors`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `monitors`
| `array (string)`
| monitors is Required: Monitors is a collection of Ceph monitors More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

| `path`
| `string`
| path is Optional: Used as the mounted root, rather than the full Ceph tree, default is /

| `readOnly`
| `boolean`
| readOnly is Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

| `secretFile`
| `string`
| secretFile is Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.LocalObjectReference[`LocalObjectReference`]
| secretRef is Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

| `user`
| `string`
| user is optional: User is the rados user name, default is admin More info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it

|===

[id="io.k8s.api.core.v1.CinderPersistentVolumeSource"]
== io.k8s.api.core.v1.CinderPersistentVolumeSource schema


Description::
+
--
Represents a cinder volume resource in Openstack. A Cinder volume must exist before mounting to a container. The volume must also be in the same region as the kubelet. Cinder volumes support ownership management and SELinux relabeling.
--

Type::
  `object`

Required::
  - `volumeID`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType Filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

| `readOnly`
| `boolean`
| readOnly is Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretReference[`SecretReference`]
| secretRef is Optional: points to a secret object containing parameters used to connect to OpenStack.

| `volumeID`
| `string`
| volumeID used to identify the volume in cinder. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

|===

[id="io.k8s.api.core.v1.CinderVolumeSource"]
== io.k8s.api.core.v1.CinderVolumeSource schema


Description::
+
--
Represents a cinder volume resource in Openstack. A Cinder volume must exist before mounting to a container. The volume must also be in the same region as the kubelet. Cinder volumes support ownership management and SELinux relabeling.
--

Type::
  `object`

Required::
  - `volumeID`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is the filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

| `readOnly`
| `boolean`
| readOnly defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.LocalObjectReference[`LocalObjectReference`]
| secretRef is optional: points to a secret object containing parameters used to connect to OpenStack.

| `volumeID`
| `string`
| volumeID used to identify the volume in cinder. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

|===

[id="io.k8s.api.core.v1.ClaimSource"]
== io.k8s.api.core.v1.ClaimSource schema


Description::
+
--
ClaimSource describes a reference to a ResourceClaim.

Exactly one of these fields should be set.  Consumers of this type must treat an empty object as if it has an unknown value.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `resourceClaimName`
| `string`
| ResourceClaimName is the name of a ResourceClaim object in the same namespace as this pod.

| `resourceClaimTemplateName`
| `string`
| ResourceClaimTemplateName is the name of a ResourceClaimTemplate object in the same namespace as this pod.

The template will be used to create a new ResourceClaim, which will be bound to this pod. When this pod is deleted, the ResourceClaim will also be deleted. The name of the ResourceClaim will be <pod name>-<resource name>, where <resource name> is the PodResourceClaim.Name. Pod validation will reject the pod if the concatenated name is not valid for a ResourceClaim (e.g. too long).

An existing ResourceClaim with that name that is not owned by the pod will not be used for the pod to avoid using an unrelated resource by mistake. Scheduling and pod startup are then blocked until the unrelated ResourceClaim is removed.

This field is immutable and no changes will be made to the corresponding ResourceClaim by the control plane after creating the ResourceClaim.

|===

[id="io.k8s.api.core.v1.ComponentStatusList"]
== io.k8s.api.core.v1.ComponentStatusList schema


Description::
+
--
Status of all the conditions for the component as a list of ComponentStatus objects. Deprecated: This API is deprecated in v1.19+
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/componentstatus-v1.adoc#componentstatus-v1[`array (ComponentStatus)`]
| List of ComponentStatus objects.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.ConfigMapEnvSource"]
== io.k8s.api.core.v1.ConfigMapEnvSource schema


Description::
+
--
ConfigMapEnvSource selects a ConfigMap to populate the environment variables with.

The contents of the target ConfigMap's Data field will represent the key-value pairs as environment variables.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

| `optional`
| `boolean`
| Specify whether the ConfigMap must be defined

|===

[id="io.k8s.api.core.v1.ConfigMapKeySelector"]
== io.k8s.api.core.v1.ConfigMapKeySelector schema


Description::
+
--
Selects a key from a ConfigMap.
--

Type::
  `object`

Required::
  - `key`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `key`
| `string`
| The key to select.

| `name`
| `string`
| Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

| `optional`
| `boolean`
| Specify whether the ConfigMap or its key must be defined

|===

[id="io.k8s.api.core.v1.ConfigMapList"]
== io.k8s.api.core.v1.ConfigMapList schema


Description::
+
--
ConfigMapList is a resource containing a list of ConfigMap objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/configmap-v1.adoc#configmap-v1[`array (ConfigMap)`]
| Items is the list of ConfigMaps.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.core.v1.ConfigMapProjection"]
== io.k8s.api.core.v1.ConfigMapProjection schema


Description::
+
--
Adapts a ConfigMap into a projected volume.

The contents of the target ConfigMap's Data field will be presented in a projected volume as files using the keys in the Data field as the file names, unless the items element is populated with specific mappings of keys to paths. Note that this is identical to a configmap volume source without the default mode.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `items`
| xref:../objects/index.adoc#io.k8s.api.core.v1.KeyToPath[`array (KeyToPath)`]
| items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.

| `name`
| `string`
| Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

| `optional`
| `boolean`
| optional specify whether the ConfigMap or its keys must be defined

|===

[id="io.k8s.api.core.v1.ConfigMapVolumeSource"]
== io.k8s.api.core.v1.ConfigMapVolumeSource schema


Description::
+
--
Adapts a ConfigMap into a volume.

The contents of the target ConfigMap's Data field will be presented in a volume as files using the keys in the Data field as the file names, unless the items element is populated with specific mappings of keys to paths. ConfigMap volumes support ownership management and SELinux relabeling.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `defaultMode`
| `integer`
| defaultMode is optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

| `items`
| xref:../objects/index.adoc#io.k8s.api.core.v1.KeyToPath[`array (KeyToPath)`]
| items if unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.

| `name`
| `string`
| Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

| `optional`
| `boolean`
| optional specify whether the ConfigMap or its keys must be defined

|===

[id="io.k8s.api.core.v1.Container"]
== io.k8s.api.core.v1.Container schema


Description::
+
--
A single application container that you want to run within a pod.
--

Type::
  `object`

Required::
  - `name`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `args`
| `array (string)`
| Arguments to the entrypoint. The container image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

| `command`
| `array (string)`
| Entrypoint array. Not executed within a shell. The container image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

| `env`
| xref:../objects/index.adoc#io.k8s.api.core.v1.EnvVar[`array (EnvVar)`]
| List of environment variables to set in the container. Cannot be updated.

| `envFrom`
| xref:../objects/index.adoc#io.k8s.api.core.v1.EnvFromSource[`array (EnvFromSource)`]
| List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.

| `image`
| `string`
| Container image name. More info: https://kubernetes.io/docs/concepts/containers/images This field is optional to allow higher level config management to default or override container images in workload controllers like Deployments and StatefulSets.

| `imagePullPolicy`
| `string`
| Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images

Possible enum values:
 - `"Always"` means that kubelet always attempts to pull the latest image. Container will fail If the pull fails.
 - `"IfNotPresent"` means that kubelet pulls if the image isn't present on disk. Container will fail if the image isn't present and the pull fails.
 - `"Never"` means that kubelet never pulls an image, but only uses a local image. Container will fail if the image isn't present

| `lifecycle`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Lifecycle[`Lifecycle`]
| Actions that the management system should take in response to container lifecycle events. Cannot be updated.

| `livenessProbe`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Probe[`Probe`]
| Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

| `name`
| `string`
| Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated.

| `ports`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ContainerPort[`array (ContainerPort)`]
| List of ports to expose from the container. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default "0.0.0.0" address inside a container will be accessible from the network. Modifying this array with strategic merge patch may corrupt the data. For more information See https://github.com/kubernetes/kubernetes/issues/108255. Cannot be updated.

| `readinessProbe`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Probe[`Probe`]
| Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

| `resizePolicy`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ContainerResizePolicy[`array (ContainerResizePolicy)`]
| Resources resize policy for the container.

| `resources`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ResourceRequirements[`ResourceRequirements`]
| Compute Resources required by this container. Cannot be updated. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

| `securityContext`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecurityContext[`SecurityContext`]
| SecurityContext defines the security options the container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext. More info: https://kubernetes.io/docs/tasks/configure-pod-container/security-context/

| `startupProbe`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Probe[`Probe`]
| StartupProbe indicates that the Pod has successfully initialized. If specified, no other probes are executed until this completes successfully. If this probe fails, the Pod will be restarted, just as if the livenessProbe failed. This can be used to provide different probe parameters at the beginning of a Pod's lifecycle, when it might take a long time to load data or warm a cache, than during steady-state operation. This cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

| `stdin`
| `boolean`
| Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.

| `stdinOnce`
| `boolean`
| Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false

| `terminationMessagePath`
| `string`
| Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.

| `terminationMessagePolicy`
| `string`
| Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.

Possible enum values:
 - `"FallbackToLogsOnError"` will read the most recent contents of the container logs for the container status message when the container exits with an error and the terminationMessagePath has no contents.
 - `"File"` is the default behavior and will set the container status message to the contents of the container's terminationMessagePath when the container exits.

| `tty`
| `boolean`
| Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.

| `volumeDevices`
| xref:../objects/index.adoc#io.k8s.api.core.v1.VolumeDevice[`array (VolumeDevice)`]
| volumeDevices is the list of block devices to be used by the container.

| `volumeMounts`
| xref:../objects/index.adoc#io.k8s.api.core.v1.VolumeMount[`array (VolumeMount)`]
| Pod volumes to mount into the container's filesystem. Cannot be updated.

| `workingDir`
| `string`
| Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

|===

[id="io.k8s.api.core.v1.ContainerPort"]
== io.k8s.api.core.v1.ContainerPort schema


Description::
+
--
ContainerPort represents a network port in a single container.
--

Type::
  `object`

Required::
  - `containerPort`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `containerPort`
| `integer`
| Number of port to expose on the pod's IP address. This must be a valid port number, 0 < x < 65536.

| `hostIP`
| `string`
| What host IP to bind the external port to.

| `hostPort`
| `integer`
| Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this.

| `name`
| `string`
| If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services.

| `protocol`
| `string`
| Protocol for port. Must be UDP, TCP, or SCTP. Defaults to "TCP".

Possible enum values:
 - `"SCTP"` is the SCTP protocol.
 - `"TCP"` is the TCP protocol.
 - `"UDP"` is the UDP protocol.

|===

[id="io.k8s.api.core.v1.ContainerResizePolicy"]
== io.k8s.api.core.v1.ContainerResizePolicy schema


Description::
+
--
ContainerResizePolicy represents resource resize policy for the container.
--

Type::
  `object`

Required::
  - `resourceName`
  - `restartPolicy`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `resourceName`
| `string`
| Name of the resource to which this resource resize policy applies. Supported values: cpu, memory.

| `restartPolicy`
| `string`
| Restart policy to apply when specified resource is resized. If not specified, it defaults to NotRequired.

|===

[id="io.k8s.api.core.v1.CSIPersistentVolumeSource"]
== io.k8s.api.core.v1.CSIPersistentVolumeSource schema


Description::
+
--
Represents storage that is managed by an external CSI volume driver (Beta feature)
--

Type::
  `object`

Required::
  - `driver`
  - `volumeHandle`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `controllerExpandSecretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretReference[`SecretReference`]
| controllerExpandSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerExpandVolume call. This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.

| `controllerPublishSecretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretReference[`SecretReference`]
| controllerPublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI ControllerPublishVolume and ControllerUnpublishVolume calls. This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.

| `driver`
| `string`
| driver is the name of the driver to use for this volume. Required.

| `fsType`
| `string`
| fsType to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs".

| `nodeExpandSecretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretReference[`SecretReference`]
| nodeExpandSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeExpandVolume call. This is a beta field which is enabled default by CSINodeExpandSecret feature gate. This field is optional, may be omitted if no secret is required. If the secret object contains more than one secret, all secrets are passed.

| `nodePublishSecretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretReference[`SecretReference`]
| nodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.

| `nodeStageSecretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretReference[`SecretReference`]
| nodeStageSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodeStageVolume and NodeStageVolume and NodeUnstageVolume calls. This field is optional, and may be empty if no secret is required. If the secret object contains more than one secret, all secrets are passed.

| `readOnly`
| `boolean`
| readOnly value to pass to ControllerPublishVolumeRequest. Defaults to false (read/write).

| `volumeAttributes`
| `object (string)`
| volumeAttributes of the volume to publish.

| `volumeHandle`
| `string`
| volumeHandle is the unique volume name returned by the CSI volume plugin’s CreateVolume to refer to the volume on all subsequent calls. Required.

|===

[id="io.k8s.api.core.v1.CSIVolumeSource"]
== io.k8s.api.core.v1.CSIVolumeSource schema


Description::
+
--
Represents a source location of a volume to mount, managed by an external CSI driver
--

Type::
  `object`

Required::
  - `driver`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `driver`
| `string`
| driver is the name of the CSI driver that handles this volume. Consult with your admin for the correct name as registered in the cluster.

| `fsType`
| `string`
| fsType to mount. Ex. "ext4", "xfs", "ntfs". If not provided, the empty value is passed to the associated CSI driver which will determine the default filesystem to apply.

| `nodePublishSecretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.LocalObjectReference[`LocalObjectReference`]
| nodePublishSecretRef is a reference to the secret object containing sensitive information to pass to the CSI driver to complete the CSI NodePublishVolume and NodeUnpublishVolume calls. This field is optional, and  may be empty if no secret is required. If the secret object contains more than one secret, all secret references are passed.

| `readOnly`
| `boolean`
| readOnly specifies a read-only configuration for the volume. Defaults to false (read/write).

| `volumeAttributes`
| `object (string)`
| volumeAttributes stores driver-specific properties that are passed to the CSI driver. Consult your driver's documentation for supported values.

|===

[id="io.k8s.api.core.v1.DownwardAPIProjection"]
== io.k8s.api.core.v1.DownwardAPIProjection schema


Description::
+
--
Represents downward API info for projecting into a projected volume. Note that this is identical to a downwardAPI volume source without the default mode.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `items`
| xref:../objects/index.adoc#io.k8s.api.core.v1.DownwardAPIVolumeFile[`array (DownwardAPIVolumeFile)`]
| Items is a list of DownwardAPIVolume file

|===

[id="io.k8s.api.core.v1.DownwardAPIVolumeFile"]
== io.k8s.api.core.v1.DownwardAPIVolumeFile schema


Description::
+
--
DownwardAPIVolumeFile represents information to create the file containing the pod field
--

Type::
  `object`

Required::
  - `path`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fieldRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ObjectFieldSelector[`ObjectFieldSelector`]
| Required: Selects a field of the pod: only annotations, labels, name and namespace are supported.

| `mode`
| `integer`
| Optional: mode bits used to set permissions on this file, must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

| `path`
| `string`
| Required: Path is  the relative path name of the file to be created. Must not be absolute or contain the '..' path. Must be utf-8 encoded. The first item of the relative path must not start with '..'

| `resourceFieldRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ResourceFieldSelector[`ResourceFieldSelector`]
| Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported.

|===

[id="io.k8s.api.core.v1.DownwardAPIVolumeSource"]
== io.k8s.api.core.v1.DownwardAPIVolumeSource schema


Description::
+
--
DownwardAPIVolumeSource represents a volume containing downward API info. Downward API volumes support ownership management and SELinux relabeling.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `defaultMode`
| `integer`
| Optional: mode bits to use on created files by default. Must be a Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

| `items`
| xref:../objects/index.adoc#io.k8s.api.core.v1.DownwardAPIVolumeFile[`array (DownwardAPIVolumeFile)`]
| Items is a list of downward API volume file

|===

[id="io.k8s.api.core.v1.EmptyDirVolumeSource"]
== io.k8s.api.core.v1.EmptyDirVolumeSource schema


Description::
+
--
Represents an empty directory for a pod. Empty directory volumes support ownership management and SELinux relabeling.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `medium`
| `string`
| medium represents what type of storage medium should back this directory. The default is "" which means to use the node's default medium. Must be an empty string (default) or Memory. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir

| `sizeLimit`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.api.resource.Quantity[`Quantity`]
| sizeLimit is the total amount of local storage required for this EmptyDir volume. The size limit is also applicable for memory medium. The maximum usage on memory medium EmptyDir would be the minimum value between the SizeLimit specified here and the sum of memory limits of all containers in a pod. The default is nil which means that the limit is undefined. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir

|===

[id="io.k8s.api.core.v1.EndpointsList"]
== io.k8s.api.core.v1.EndpointsList schema


Description::
+
--
EndpointsList is a list of endpoints.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/endpoints-v1.adoc#endpoints-v1[`array (Endpoints)`]
| List of endpoints.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.EnvFromSource"]
== io.k8s.api.core.v1.EnvFromSource schema


Description::
+
--
EnvFromSource represents the source of a set of ConfigMaps
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `configMapRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ConfigMapEnvSource[`ConfigMapEnvSource`]
| The ConfigMap to select from

| `prefix`
| `string`
| An optional identifier to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER.

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretEnvSource[`SecretEnvSource`]
| The Secret to select from

|===

[id="io.k8s.api.core.v1.EnvVar"]
== io.k8s.api.core.v1.EnvVar schema


Description::
+
--
EnvVar represents an environment variable present in a Container.
--

Type::
  `object`

Required::
  - `name`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| Name of the environment variable. Must be a C_IDENTIFIER.

| `value`
| `string`
| Variable references $(VAR_NAME) are expanded using the previously defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "".

| `valueFrom`
| xref:../objects/index.adoc#io.k8s.api.core.v1.EnvVarSource[`EnvVarSource`]
| Source for the environment variable's value. Cannot be used if value is not empty.

|===

[id="io.k8s.api.core.v1.EnvVarSource"]
== io.k8s.api.core.v1.EnvVarSource schema


Description::
+
--
EnvVarSource represents a source for the value of an EnvVar.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `configMapKeyRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ConfigMapKeySelector[`ConfigMapKeySelector`]
| Selects a key of a ConfigMap.

| `fieldRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ObjectFieldSelector[`ObjectFieldSelector`]
| Selects a field of the pod: supports metadata.name, metadata.namespace, `metadata.labels['<KEY>']`, `metadata.annotations['<KEY>']`, spec.nodeName, spec.serviceAccountName, status.hostIP, status.podIP, status.podIPs.

| `resourceFieldRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ResourceFieldSelector[`ResourceFieldSelector`]
| Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, limits.ephemeral-storage, requests.cpu, requests.memory and requests.ephemeral-storage) are currently supported.

| `secretKeyRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretKeySelector[`SecretKeySelector`]
| Selects a key of a secret in the pod's namespace

|===

[id="io.k8s.api.core.v1.EphemeralContainer"]
== io.k8s.api.core.v1.EphemeralContainer schema


Description::
+
--
An EphemeralContainer is a temporary container that you may add to an existing Pod for user-initiated activities such as debugging. Ephemeral containers have no resource or scheduling guarantees, and they will not be restarted when they exit or when a Pod is removed or restarted. The kubelet may evict a Pod if an ephemeral container causes the Pod to exceed its resource allocation.

To add an ephemeral container, use the ephemeralcontainers subresource of an existing Pod. Ephemeral containers may not be removed or restarted.
--

Type::
  `object`

Required::
  - `name`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `args`
| `array (string)`
| Arguments to the entrypoint. The image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

| `command`
| `array (string)`
| Entrypoint array. Not executed within a shell. The image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. "$$(VAR_NAME)" will produce the string literal "$(VAR_NAME)". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell

| `env`
| xref:../objects/index.adoc#io.k8s.api.core.v1.EnvVar[`array (EnvVar)`]
| List of environment variables to set in the container. Cannot be updated.

| `envFrom`
| xref:../objects/index.adoc#io.k8s.api.core.v1.EnvFromSource[`array (EnvFromSource)`]
| List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.

| `image`
| `string`
| Container image name. More info: https://kubernetes.io/docs/concepts/containers/images

| `imagePullPolicy`
| `string`
| Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images

Possible enum values:
 - `"Always"` means that kubelet always attempts to pull the latest image. Container will fail If the pull fails.
 - `"IfNotPresent"` means that kubelet pulls if the image isn't present on disk. Container will fail if the image isn't present and the pull fails.
 - `"Never"` means that kubelet never pulls an image, but only uses a local image. Container will fail if the image isn't present

| `lifecycle`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Lifecycle[`Lifecycle`]
| Lifecycle is not allowed for ephemeral containers.

| `livenessProbe`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Probe[`Probe`]
| Probes are not allowed for ephemeral containers.

| `name`
| `string`
| Name of the ephemeral container specified as a DNS_LABEL. This name must be unique among all containers, init containers and ephemeral containers.

| `ports`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ContainerPort[`array (ContainerPort)`]
| Ports are not allowed for ephemeral containers.

| `readinessProbe`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Probe[`Probe`]
| Probes are not allowed for ephemeral containers.

| `resizePolicy`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ContainerResizePolicy[`array (ContainerResizePolicy)`]
| Resources resize policy for the container.

| `resources`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ResourceRequirements[`ResourceRequirements`]
| Resources are not allowed for ephemeral containers. Ephemeral containers use spare resources already allocated to the pod.

| `securityContext`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecurityContext[`SecurityContext`]
| Optional: SecurityContext defines the security options the ephemeral container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext.

| `startupProbe`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Probe[`Probe`]
| Probes are not allowed for ephemeral containers.

| `stdin`
| `boolean`
| Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.

| `stdinOnce`
| `boolean`
| Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false

| `targetContainerName`
| `string`
| If set, the name of the container from PodSpec that this ephemeral container targets. The ephemeral container will be run in the namespaces (IPC, PID, etc) of this container. If not set then the ephemeral container uses the namespaces configured in the Pod spec.

The container runtime must implement support for this feature. If the runtime does not support namespace targeting then the result of setting this field is undefined.

| `terminationMessagePath`
| `string`
| Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.

| `terminationMessagePolicy`
| `string`
| Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.

Possible enum values:
 - `"FallbackToLogsOnError"` will read the most recent contents of the container logs for the container status message when the container exits with an error and the terminationMessagePath has no contents.
 - `"File"` is the default behavior and will set the container status message to the contents of the container's terminationMessagePath when the container exits.

| `tty`
| `boolean`
| Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.

| `volumeDevices`
| xref:../objects/index.adoc#io.k8s.api.core.v1.VolumeDevice[`array (VolumeDevice)`]
| volumeDevices is the list of block devices to be used by the container.

| `volumeMounts`
| xref:../objects/index.adoc#io.k8s.api.core.v1.VolumeMount[`array (VolumeMount)`]
| Pod volumes to mount into the container's filesystem. Subpath mounts are not allowed for ephemeral containers. Cannot be updated.

| `workingDir`
| `string`
| Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.

|===

[id="io.k8s.api.core.v1.EphemeralVolumeSource"]
== io.k8s.api.core.v1.EphemeralVolumeSource schema


Description::
+
--
Represents an ephemeral volume that is handled by a normal storage driver.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `volumeClaimTemplate`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PersistentVolumeClaimTemplate[`PersistentVolumeClaimTemplate`]
| Will be used to create a stand-alone PVC to provision the volume. The pod in which this EphemeralVolumeSource is embedded will be the owner of the PVC, i.e. the PVC will be deleted together with the pod.  The name of the PVC will be `<pod name>-<volume name>` where `<volume name>` is the name from the `PodSpec.Volumes` array entry. Pod validation will reject the pod if the concatenated name is not valid for a PVC (for example, too long).

An existing PVC with that name that is not owned by the pod will *not* be used for the pod to avoid using an unrelated volume by mistake. Starting the pod is then blocked until the unrelated PVC is removed. If such a pre-created PVC is meant to be used by the pod, the PVC has to updated with an owner reference to the pod once the pod exists. Normally this should not be necessary, but it may be useful when manually reconstructing a broken cluster.

This field is read-only and no changes will be made by Kubernetes to the PVC after it has been created.

Required, must not be nil.

|===

[id="io.k8s.api.core.v1.EventList"]
== io.k8s.api.core.v1.EventList schema


Description::
+
--
EventList is a list of events.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/event-v1.adoc#event-v1[`array (Event)`]
| List of events

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.EventSource"]
== io.k8s.api.core.v1.EventSource schema


Description::
+
--
EventSource contains information for an event.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `component`
| `string`
| Component from which the event is generated.

| `host`
| `string`
| Node name on which the event is generated.

|===

[id="io.k8s.api.core.v1.ExecAction"]
== io.k8s.api.core.v1.ExecAction schema


Description::
+
--
ExecAction describes a "run in container" action.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `command`
| `array (string)`
| Command is the command line to execute inside the container, the working directory for the command  is root ('/') in the container's filesystem. The command is simply exec'd, it is not run inside a shell, so traditional shell instructions ('\|', etc) won't work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy.

|===

[id="io.k8s.api.core.v1.FCVolumeSource"]
== io.k8s.api.core.v1.FCVolumeSource schema


Description::
+
--
Represents a Fibre Channel volume. Fibre Channel volumes can only be mounted as read/write once. Fibre Channel volumes support ownership management and SELinux relabeling.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is the filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

| `lun`
| `integer`
| lun is Optional: FC target lun number

| `readOnly`
| `boolean`
| readOnly is Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

| `targetWWNs`
| `array (string)`
| targetWWNs is Optional: FC target worldwide names (WWNs)

| `wwids`
| `array (string)`
| wwids Optional: FC volume world wide identifiers (wwids) Either wwids or combination of targetWWNs and lun must be set, but not both simultaneously.

|===

[id="io.k8s.api.core.v1.FlexPersistentVolumeSource"]
== io.k8s.api.core.v1.FlexPersistentVolumeSource schema


Description::
+
--
FlexPersistentVolumeSource represents a generic persistent volume resource that is provisioned/attached using an exec based plugin.
--

Type::
  `object`

Required::
  - `driver`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `driver`
| `string`
| driver is the name of the driver to use for this volume.

| `fsType`
| `string`
| fsType is the Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script.

| `options`
| `object (string)`
| options is Optional: this field holds extra command options if any.

| `readOnly`
| `boolean`
| readOnly is Optional: defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretReference[`SecretReference`]
| secretRef is Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.

|===

[id="io.k8s.api.core.v1.FlexVolumeSource"]
== io.k8s.api.core.v1.FlexVolumeSource schema


Description::
+
--
FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.
--

Type::
  `object`

Required::
  - `driver`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `driver`
| `string`
| driver is the name of the driver to use for this volume.

| `fsType`
| `string`
| fsType is the filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script.

| `options`
| `object (string)`
| options is Optional: this field holds extra command options if any.

| `readOnly`
| `boolean`
| readOnly is Optional: defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.LocalObjectReference[`LocalObjectReference`]
| secretRef is Optional: secretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts.

|===

[id="io.k8s.api.core.v1.FlockerVolumeSource"]
== io.k8s.api.core.v1.FlockerVolumeSource schema


Description::
+
--
Represents a Flocker volume mounted by the Flocker agent. One and only one of datasetName and datasetUUID should be set. Flocker volumes do not support ownership management or SELinux relabeling.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `datasetName`
| `string`
| datasetName is Name of the dataset stored as metadata -> name on the dataset for Flocker should be considered as deprecated

| `datasetUUID`
| `string`
| datasetUUID is the UUID of the dataset. This is unique identifier of a Flocker dataset

|===

[id="io.k8s.api.core.v1.GCEPersistentDiskVolumeSource"]
== io.k8s.api.core.v1.GCEPersistentDiskVolumeSource schema


Description::
+
--
Represents a Persistent Disk resource in Google Compute Engine.

A GCE PD must exist before mounting to a container. The disk must also be in the same GCE project and zone as the kubelet. A GCE PD can only be mounted as read/write once or read-only many times. GCE PDs support ownership management and SELinux relabeling.
--

Type::
  `object`

Required::
  - `pdName`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

| `partition`
| `integer`
| partition is the partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty). More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

| `pdName`
| `string`
| pdName is unique name of the PD resource in GCE. Used to identify the disk in GCE. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

| `readOnly`
| `boolean`
| readOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

|===

[id="io.k8s.api.core.v1.GitRepoVolumeSource"]
== io.k8s.api.core.v1.GitRepoVolumeSource schema


Description::
+
--
Represents a volume that is populated with the contents of a git repository. Git repo volumes do not support ownership management. Git repo volumes support SELinux relabeling.

DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir into the Pod's container.
--

Type::
  `object`

Required::
  - `repository`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `directory`
| `string`
| directory is the target directory name. Must not contain or start with '..'.  If '.' is supplied, the volume directory will be the git repository.  Otherwise, if specified, the volume will contain the git repository in the subdirectory with the given name.

| `repository`
| `string`
| repository is the URL

| `revision`
| `string`
| revision is the commit hash for the specified revision.

|===

[id="io.k8s.api.core.v1.GlusterfsPersistentVolumeSource"]
== io.k8s.api.core.v1.GlusterfsPersistentVolumeSource schema


Description::
+
--
Represents a Glusterfs mount that lasts the lifetime of a pod. Glusterfs volumes do not support ownership management or SELinux relabeling.
--

Type::
  `object`

Required::
  - `endpoints`
  - `path`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `endpoints`
| `string`
| endpoints is the endpoint name that details Glusterfs topology. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

| `endpointsNamespace`
| `string`
| endpointsNamespace is the namespace that contains Glusterfs endpoint. If this field is empty, the EndpointNamespace defaults to the same namespace as the bound PVC. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

| `path`
| `string`
| path is the Glusterfs volume path. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

| `readOnly`
| `boolean`
| readOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

|===

[id="io.k8s.api.core.v1.GlusterfsVolumeSource"]
== io.k8s.api.core.v1.GlusterfsVolumeSource schema


Description::
+
--
Represents a Glusterfs mount that lasts the lifetime of a pod. Glusterfs volumes do not support ownership management or SELinux relabeling.
--

Type::
  `object`

Required::
  - `endpoints`
  - `path`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `endpoints`
| `string`
| endpoints is the endpoint name that details Glusterfs topology. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

| `path`
| `string`
| path is the Glusterfs volume path. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

| `readOnly`
| `boolean`
| readOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod

|===

[id="io.k8s.api.core.v1.GRPCAction"]
== io.k8s.api.core.v1.GRPCAction schema


Description::
+
--

--

Type::
  `object`

Required::
  - `port`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `port`
| `integer`
| Port number of the gRPC service. Number must be in the range 1 to 65535.

| `service`
| `string`
| Service is the name of the service to place in the gRPC HealthCheckRequest (see https://github.com/grpc/grpc/blob/master/doc/health-checking.md).

If this is not specified, the default behavior is defined by gRPC.

|===

[id="io.k8s.api.core.v1.HostAlias"]
== io.k8s.api.core.v1.HostAlias schema


Description::
+
--
HostAlias holds the mapping between IP and hostnames that will be injected as an entry in the pod's hosts file.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `hostnames`
| `array (string)`
| Hostnames for the above IP address.

| `ip`
| `string`
| IP address of the host file entry.

|===

[id="io.k8s.api.core.v1.HostPathVolumeSource"]
== io.k8s.api.core.v1.HostPathVolumeSource schema


Description::
+
--
Represents a host path mapped into a pod. Host path volumes do not support ownership management or SELinux relabeling.
--

Type::
  `object`

Required::
  - `path`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `path`
| `string`
| path of the directory on the host. If the path is a symlink, it will follow the link to the real path. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

| `type`
| `string`
| type for HostPath Volume Defaults to "" More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

Possible enum values:
 - `""` For backwards compatible, leave it empty if unset
 - `"BlockDevice"` A block device must exist at the given path
 - `"CharDevice"` A character device must exist at the given path
 - `"Directory"` A directory must exist at the given path
 - `"DirectoryOrCreate"` If nothing exists at the given path, an empty directory will be created there as needed with file mode 0755, having the same group and ownership with Kubelet.
 - `"File"` A file must exist at the given path
 - `"FileOrCreate"` If nothing exists at the given path, an empty file will be created there as needed with file mode 0644, having the same group and ownership with Kubelet.
 - `"Socket"` A UNIX socket must exist at the given path

|===

[id="io.k8s.api.core.v1.HTTPGetAction"]
== io.k8s.api.core.v1.HTTPGetAction schema


Description::
+
--
HTTPGetAction describes an action based on HTTP Get requests.
--

Type::
  `object`

Required::
  - `port`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `host`
| `string`
| Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead.

| `httpHeaders`
| xref:../objects/index.adoc#io.k8s.api.core.v1.HTTPHeader[`array (HTTPHeader)`]
| Custom headers to set in the request. HTTP allows repeated headers.

| `path`
| `string`
| Path to access on the HTTP server.

| `port`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.util.intstr.IntOrString[`IntOrString`]
| Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.

| `scheme`
| `string`
| Scheme to use for connecting to the host. Defaults to HTTP.

Possible enum values:
 - `"HTTP"` means that the scheme used will be http://
 - `"HTTPS"` means that the scheme used will be https://

|===

[id="io.k8s.api.core.v1.HTTPHeader"]
== io.k8s.api.core.v1.HTTPHeader schema


Description::
+
--
HTTPHeader describes a custom header to be used in HTTP probes
--

Type::
  `object`

Required::
  - `name`
  - `value`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| The header field name. This will be canonicalized upon output, so case-variant names will be understood as the same header.

| `value`
| `string`
| The header field value

|===

[id="io.k8s.api.core.v1.ISCSIPersistentVolumeSource"]
== io.k8s.api.core.v1.ISCSIPersistentVolumeSource schema


Description::
+
--
ISCSIPersistentVolumeSource represents an ISCSI disk. ISCSI volumes can only be mounted as read/write once. ISCSI volumes support ownership management and SELinux relabeling.
--

Type::
  `object`

Required::
  - `targetPortal`
  - `iqn`
  - `lun`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `chapAuthDiscovery`
| `boolean`
| chapAuthDiscovery defines whether support iSCSI Discovery CHAP authentication

| `chapAuthSession`
| `boolean`
| chapAuthSession defines whether support iSCSI Session CHAP authentication

| `fsType`
| `string`
| fsType is the filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi

| `initiatorName`
| `string`
| initiatorName is the custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.

| `iqn`
| `string`
| iqn is Target iSCSI Qualified Name.

| `iscsiInterface`
| `string`
| iscsiInterface is the interface Name that uses an iSCSI transport. Defaults to 'default' (tcp).

| `lun`
| `integer`
| lun is iSCSI Target Lun number.

| `portals`
| `array (string)`
| portals is the iSCSI Target Portal List. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

| `readOnly`
| `boolean`
| readOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false.

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretReference[`SecretReference`]
| secretRef is the CHAP Secret for iSCSI target and initiator authentication

| `targetPortal`
| `string`
| targetPortal is iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

|===

[id="io.k8s.api.core.v1.ISCSIVolumeSource"]
== io.k8s.api.core.v1.ISCSIVolumeSource schema


Description::
+
--
Represents an ISCSI disk. ISCSI volumes can only be mounted as read/write once. ISCSI volumes support ownership management and SELinux relabeling.
--

Type::
  `object`

Required::
  - `targetPortal`
  - `iqn`
  - `lun`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `chapAuthDiscovery`
| `boolean`
| chapAuthDiscovery defines whether support iSCSI Discovery CHAP authentication

| `chapAuthSession`
| `boolean`
| chapAuthSession defines whether support iSCSI Session CHAP authentication

| `fsType`
| `string`
| fsType is the filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi

| `initiatorName`
| `string`
| initiatorName is the custom iSCSI Initiator Name. If initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface <target portal>:<volume name> will be created for the connection.

| `iqn`
| `string`
| iqn is the target iSCSI Qualified Name.

| `iscsiInterface`
| `string`
| iscsiInterface is the interface Name that uses an iSCSI transport. Defaults to 'default' (tcp).

| `lun`
| `integer`
| lun represents iSCSI Target Lun number.

| `portals`
| `array (string)`
| portals is the iSCSI Target Portal List. The portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

| `readOnly`
| `boolean`
| readOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false.

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.LocalObjectReference[`LocalObjectReference`]
| secretRef is the CHAP Secret for iSCSI target and initiator authentication

| `targetPortal`
| `string`
| targetPortal is iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260).

|===

[id="io.k8s.api.core.v1.KeyToPath"]
== io.k8s.api.core.v1.KeyToPath schema


Description::
+
--
Maps a string key to a path within a volume.
--

Type::
  `object`

Required::
  - `key`
  - `path`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `key`
| `string`
| key is the key to project.

| `mode`
| `integer`
| mode is Optional: mode bits used to set permissions on this file. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

| `path`
| `string`
| path is the relative path of the file to map the key to. May not be an absolute path. May not contain the path element '..'. May not start with the string '..'.

|===

[id="io.k8s.api.core.v1.Lifecycle"]
== io.k8s.api.core.v1.Lifecycle schema


Description::
+
--
Lifecycle describes actions that the management system should take in response to container lifecycle events. For the PostStart and PreStop lifecycle handlers, management of the container blocks until the action is complete, unless the container process fails, in which case the handler is aborted.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `postStart`
| xref:../objects/index.adoc#io.k8s.api.core.v1.LifecycleHandler[`LifecycleHandler`]
| PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks

| `preStop`
| xref:../objects/index.adoc#io.k8s.api.core.v1.LifecycleHandler[`LifecycleHandler`]
| PreStop is called immediately before a container is terminated due to an API request or management event such as liveness/startup probe failure, preemption, resource contention, etc. The handler is not called if the container crashes or exits. The Pod's termination grace period countdown begins before the PreStop hook is executed. Regardless of the outcome of the handler, the container will eventually terminate within the Pod's termination grace period (unless delayed by finalizers). Other management of the container blocks until the hook completes or until the termination grace period is reached. More info: https://kubernetes.io/docs/concepts/containers/container-lifecycle-hooks/#container-hooks

|===

[id="io.k8s.api.core.v1.LifecycleHandler"]
== io.k8s.api.core.v1.LifecycleHandler schema


Description::
+
--
LifecycleHandler defines a specific action that should be taken in a lifecycle hook. One and only one of the fields, except TCPSocket must be specified.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `exec`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ExecAction[`ExecAction`]
| Exec specifies the action to take.

| `httpGet`
| xref:../objects/index.adoc#io.k8s.api.core.v1.HTTPGetAction[`HTTPGetAction`]
| HTTPGet specifies the http request to perform.

| `tcpSocket`
| xref:../objects/index.adoc#io.k8s.api.core.v1.TCPSocketAction[`TCPSocketAction`]
| Deprecated. TCPSocket is NOT supported as a LifecycleHandler and kept for the backward compatibility. There are no validation of this field and lifecycle hooks will fail in runtime when tcp handler is specified.

|===

[id="io.k8s.api.core.v1.LimitRangeList"]
== io.k8s.api.core.v1.LimitRangeList schema


Description::
+
--
LimitRangeList is a list of LimitRange items.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/limitrange-v1.adoc#limitrange-v1[`array (LimitRange)`]
| Items is a list of LimitRange objects. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.LocalObjectReference"]
== io.k8s.api.core.v1.LocalObjectReference schema


Description::
+
--
LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

|===

[id="io.k8s.api.core.v1.LocalVolumeSource"]
== io.k8s.api.core.v1.LocalVolumeSource schema


Description::
+
--
Local represents directly-attached storage with node affinity (Beta feature)
--

Type::
  `object`

Required::
  - `path`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is the filesystem type to mount. It applies only when the Path is a block device. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default value is to auto-select a filesystem if unspecified.

| `path`
| `string`
| path of the full path to the volume on the node. It can be either a directory or block device (disk, partition, ...).

|===

[id="io.k8s.api.core.v1.NamespaceList"]
== io.k8s.api.core.v1.NamespaceList schema


Description::
+
--
NamespaceList is a list of Namespaces.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/namespace-v1.adoc#namespace-v1[`array (Namespace)`]
| Items is the list of Namespace objects in the list. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.NFSVolumeSource"]
== io.k8s.api.core.v1.NFSVolumeSource schema


Description::
+
--
Represents an NFS mount that lasts the lifetime of a pod. NFS volumes do not support ownership management or SELinux relabeling.
--

Type::
  `object`

Required::
  - `server`
  - `path`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `path`
| `string`
| path that is exported by the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

| `readOnly`
| `boolean`
| readOnly here will force the NFS export to be mounted with read-only permissions. Defaults to false. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

| `server`
| `string`
| server is the hostname or IP address of the NFS server. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

|===

[id="io.k8s.api.core.v1.NodeAffinity"]
== io.k8s.api.core.v1.NodeAffinity schema


Description::
+
--
Node affinity is a group of node affinity scheduling rules.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `preferredDuringSchedulingIgnoredDuringExecution`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PreferredSchedulingTerm[`array (PreferredSchedulingTerm)`]
| The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred.

| `requiredDuringSchedulingIgnoredDuringExecution`
| xref:../objects/index.adoc#io.k8s.api.core.v1.NodeSelector[`NodeSelector`]
| If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node.

|===

[id="io.k8s.api.core.v1.NodeList"]
== io.k8s.api.core.v1.NodeList schema


Description::
+
--
NodeList is the whole list of all Nodes which have been registered with master.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/node-v1.adoc#node-v1[`array (Node)`]
| List of nodes

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.NodeSelector"]
== io.k8s.api.core.v1.NodeSelector schema


Description::
+
--
A node selector represents the union of the results of one or more label queries over a set of nodes; that is, it represents the OR of the selectors represented by the node selector terms.
--

Type::
  `object`

Required::
  - `nodeSelectorTerms`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `nodeSelectorTerms`
| xref:../objects/index.adoc#io.k8s.api.core.v1.NodeSelectorTerm[`array (NodeSelectorTerm)`]
| Required. A list of node selector terms. The terms are ORed.

|===

[id="io.k8s.api.core.v1.NodeSelectorRequirement"]
== io.k8s.api.core.v1.NodeSelectorRequirement schema


Description::
+
--
A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
--

Type::
  `object`

Required::
  - `key`
  - `operator`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `key`
| `string`
| The label key that the selector applies to.

| `operator`
| `string`
| Represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt.

Possible enum values:
 - `"DoesNotExist"`
 - `"Exists"`
 - `"Gt"`
 - `"In"`
 - `"Lt"`
 - `"NotIn"`

| `values`
| `array (string)`
| An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch.

|===

[id="io.k8s.api.core.v1.NodeSelectorTerm"]
== io.k8s.api.core.v1.NodeSelectorTerm schema


Description::
+
--
A null or empty node selector term matches no objects. The requirements of them are ANDed. The TopologySelectorTerm type implements a subset of the NodeSelectorTerm.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `matchExpressions`
| xref:../objects/index.adoc#io.k8s.api.core.v1.NodeSelectorRequirement[`array (NodeSelectorRequirement)`]
| A list of node selector requirements by node's labels.

| `matchFields`
| xref:../objects/index.adoc#io.k8s.api.core.v1.NodeSelectorRequirement[`array (NodeSelectorRequirement)`]
| A list of node selector requirements by node's fields.

|===

[id="io.k8s.api.core.v1.ObjectFieldSelector"]
== io.k8s.api.core.v1.ObjectFieldSelector schema


Description::
+
--
ObjectFieldSelector selects an APIVersioned field of an object.
--

Type::
  `object`

Required::
  - `fieldPath`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| Version of the schema the FieldPath is written in terms of, defaults to "v1".

| `fieldPath`
| `string`
| Path of the field to select in the specified API version.

|===

[id="io.k8s.api.core.v1.ObjectReference"]
== io.k8s.api.core.v1.ObjectReference schema


Description::
+
--
ObjectReference contains enough information to let you inspect or modify the referred object.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| API version of the referent.

| `fieldPath`
| `string`
| If referring to a piece of an object instead of an entire object, this string should contain a valid JSON/Go field access statement, such as desiredState.manifest.containers[2]. For example, if the object reference is to a container within a pod, this would take on a value like: "spec.containers{name}" (where "name" refers to the name of the container that triggered the event) or if no container name is specified "spec.containers[2]" (container with index 2 in this pod). This syntax is chosen only to have some well-defined way of referencing a part of an object.

| `kind`
| `string`
| Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `name`
| `string`
| Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

| `namespace`
| `string`
| Namespace of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces/

| `resourceVersion`
| `string`
| Specific resourceVersion to which this reference is made, if any. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency

| `uid`
| `string`
| UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#uids

|===

[id="io.k8s.api.core.v1.PersistentVolumeClaim"]
== io.k8s.api.core.v1.PersistentVolumeClaim schema


Description::
+
--
PersistentVolumeClaim is a user's request for and claim to a persistent volume
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta[`ObjectMeta`]
| Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

| `spec`
| `object`
| PersistentVolumeClaimSpec describes the common attributes of storage devices and allows a Source for provider-specific attributes

| `status`
| `object`
| PersistentVolumeClaimStatus is the current status of a persistent volume claim.

|===
..spec
Description::
+
--
PersistentVolumeClaimSpec describes the common attributes of storage devices and allows a Source for provider-specific attributes
--

Type::
  `object`



[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `accessModes`
| `array (string)`
| accessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1

| `dataSource`
| `object`
| TypedLocalObjectReference contains enough information to let you locate the typed referenced object inside the same namespace.

| `dataSourceRef`
| `object`
| dataSourceRef specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the dataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, when namespace isn't specified in dataSourceRef, both fields (dataSource and dataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. When namespace is specified in dataSourceRef, dataSource isn't set to the same value and must be empty. There are three important differences between dataSource and dataSourceRef: * While dataSource only allows two specific types of objects, dataSourceRef
  allows any non-core object, as well as PersistentVolumeClaim objects.
* While dataSource ignores disallowed values (dropping them), dataSourceRef
  preserves all values, and generates an error if a disallowed value is
  specified.
* While dataSource only allows local objects, dataSourceRef allows objects
  in any namespaces.
(Beta) Using this field requires the AnyVolumeDataSource feature gate to be enabled. (Alpha) Using the namespace field of dataSourceRef requires the CrossNamespaceVolumeDataSource feature gate to be enabled.

| `resources`
| `object`
| ResourceRequirements describes the compute resource requirements.

| `selector`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.LabelSelector[`LabelSelector`]
| selector is a label query over volumes to consider for binding.

| `storageClassName`
| `string`
| storageClassName is the name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1

| `volumeMode`
| `string`
| volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec.

Possible enum values:
 - `"Block"` means the volume will not be formatted with a filesystem and will remain a raw block device.
 - `"Filesystem"` means the volume will be or is formatted with a filesystem.

| `volumeName`
| `string`
| volumeName is the binding reference to the PersistentVolume backing this claim.

|===
..spec.dataSource
Description::
+
--
TypedLocalObjectReference contains enough information to let you locate the typed referenced object inside the same namespace.
--

Type::
  `object`

Required::
  - `kind`
  - `name`


[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiGroup`
| `string`
| APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.

| `kind`
| `string`
| Kind is the type of resource being referenced

| `name`
| `string`
| Name is the name of resource being referenced

|===
..spec.dataSourceRef
Description::
+
--
dataSourceRef specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the dataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, when namespace isn't specified in dataSourceRef, both fields (dataSource and dataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. When namespace is specified in dataSourceRef, dataSource isn't set to the same value and must be empty. There are three important differences between dataSource and dataSourceRef: * While dataSource only allows two specific types of objects, dataSourceRef
  allows any non-core object, as well as PersistentVolumeClaim objects.
* While dataSource ignores disallowed values (dropping them), dataSourceRef
  preserves all values, and generates an error if a disallowed value is
  specified.
* While dataSource only allows local objects, dataSourceRef allows objects
  in any namespaces.
(Beta) Using this field requires the AnyVolumeDataSource feature gate to be enabled. (Alpha) Using the namespace field of dataSourceRef requires the CrossNamespaceVolumeDataSource feature gate to be enabled.
--

Type::
  `object`

Required::
  - `kind`
  - `name`


[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiGroup`
| `string`
| APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.

| `kind`
| `string`
| Kind is the type of resource being referenced

| `name`
| `string`
| Name is the name of resource being referenced

| `namespace`
| `string`
| Namespace is the namespace of resource being referenced Note that when a namespace is specified, a gateway.networking.k8s.io/ReferenceGrant object is required in the referent namespace to allow that namespace's owner to accept the reference. See the ReferenceGrant documentation for details. (Alpha) This field requires the CrossNamespaceVolumeDataSource feature gate to be enabled.

|===
..spec.resources
Description::
+
--
ResourceRequirements describes the compute resource requirements.
--

Type::
  `object`



[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `claims`
| `array`
| Claims lists the names of resources, defined in spec.resourceClaims, that are used by this container.

This is an alpha field and requires enabling the DynamicResourceAllocation feature gate.

This field is immutable. It can only be set for containers.

| `claims[]`
| `object`
| ResourceClaim references one entry in PodSpec.ResourceClaims.

| `limits`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.api.resource.Quantity[`object (Quantity)`]
| Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

| `requests`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.api.resource.Quantity[`object (Quantity)`]
| Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. Requests cannot exceed Limits. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

|===
..spec.resources.claims
Description::
+
--
Claims lists the names of resources, defined in spec.resourceClaims, that are used by this container.

This is an alpha field and requires enabling the DynamicResourceAllocation feature gate.

This field is immutable. It can only be set for containers.
--

Type::
  `array`


..spec.resources.claims[]
Description::
+
--
ResourceClaim references one entry in PodSpec.ResourceClaims.
--

Type::
  `object`

Required::
  - `name`


[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| Name must match the name of one entry in pod.spec.resourceClaims of the Pod where this field is used. It makes that resource available inside a container.

|===
..status
Description::
+
--
PersistentVolumeClaimStatus is the current status of a persistent volume claim.
--

Type::
  `object`



[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `accessModes`
| `array (string)`
| accessModes contains the actual access modes the volume backing the PVC has. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1

| `allocatedResources`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.api.resource.Quantity[`object (Quantity)`]
| allocatedResources is the storage resource within AllocatedResources tracks the capacity allocated to a PVC. It may be larger than the actual capacity when a volume expansion operation is requested. For storage quota, the larger value from allocatedResources and PVC.spec.resources is used. If allocatedResources is not set, PVC.spec.resources alone is used for quota calculation. If a volume expansion capacity request is lowered, allocatedResources is only lowered if there are no expansion operations in progress and if the actual volume capacity is equal or lower than the requested capacity. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.

| `capacity`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.api.resource.Quantity[`object (Quantity)`]
| capacity represents the actual resources of the underlying volume.

| `conditions`
| `array`
| conditions is the current Condition of persistent volume claim. If underlying persistent volume is being resized then the Condition will be set to 'ResizeStarted'.

| `conditions[]`
| `object`
| PersistentVolumeClaimCondition contains details about state of pvc

| `phase`
| `string`
| phase represents the current phase of PersistentVolumeClaim.

Possible enum values:
 - `"Bound"` used for PersistentVolumeClaims that are bound
 - `"Lost"` used for PersistentVolumeClaims that lost their underlying PersistentVolume. The claim was bound to a PersistentVolume and this volume does not exist any longer and all data on it was lost.
 - `"Pending"` used for PersistentVolumeClaims that are not yet bound

| `resizeStatus`
| `string`
| resizeStatus stores status of resize operation. ResizeStatus is not set by default but when expansion is complete resizeStatus is set to empty string by resize controller or kubelet. This is an alpha field and requires enabling RecoverVolumeExpansionFailure feature.

Possible enum values:
 - `""` When expansion is complete, the empty string is set by resize controller or kubelet.
 - `"ControllerExpansionFailed"` State set when expansion has failed in resize controller with a terminal error. Transient errors such as timeout should not set this status and should leave ResizeStatus unmodified, so as resize controller can resume the volume expansion.
 - `"ControllerExpansionInProgress"` State set when resize controller starts expanding the volume in control-plane
 - `"NodeExpansionFailed"` State set when expansion has failed in kubelet with a terminal error. Transient errors don't set NodeExpansionFailed.
 - `"NodeExpansionInProgress"` State set when kubelet starts expanding the volume.
 - `"NodeExpansionPending"` State set when resize controller has finished expanding the volume but further expansion is needed on the node.

|===
..status.conditions
Description::
+
--
conditions is the current Condition of persistent volume claim. If underlying persistent volume is being resized then the Condition will be set to 'ResizeStarted'.
--

Type::
  `array`


..status.conditions[]
Description::
+
--
PersistentVolumeClaimCondition contains details about state of pvc
--

Type::
  `object`

Required::
  - `type`
  - `status`


[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `lastProbeTime`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.Time[`Time`]
| lastProbeTime is the time we probed the condition.

| `lastTransitionTime`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.Time[`Time`]
| lastTransitionTime is the time the condition transitioned from one status to another.

| `message`
| `string`
| message is the human-readable message indicating details about last transition.

| `reason`
| `string`
| reason is a unique, this should be a short, machine understandable string that gives the reason for condition's last transition. If it reports "ResizeStarted" that means the underlying persistent volume is being resized.

| `status`
| `string`
|

| `type`
| `string`
|

|===

[id="io.k8s.api.core.v1.PersistentVolumeClaimList"]
== io.k8s.api.core.v1.PersistentVolumeClaimList schema


Description::
+
--
PersistentVolumeClaimList is a list of PersistentVolumeClaim items.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/persistentvolumeclaim-v1.adoc#persistentvolumeclaim-v1[`array (PersistentVolumeClaim)`]
| items is a list of persistent volume claims. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.PersistentVolumeClaimSpec"]
== io.k8s.api.core.v1.PersistentVolumeClaimSpec schema


Description::
+
--
PersistentVolumeClaimSpec describes the common attributes of storage devices and allows a Source for provider-specific attributes
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `accessModes`
| `array (string)`
| accessModes contains the desired access modes the volume should have. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes-1

| `dataSource`
| xref:../objects/index.adoc#io.k8s.api.core.v1.TypedLocalObjectReference[`TypedLocalObjectReference`]
| dataSource field can be used to specify either: * An existing VolumeSnapshot object (snapshot.storage.k8s.io/VolumeSnapshot) * An existing PVC (PersistentVolumeClaim) If the provisioner or an external controller can support the specified data source, it will create a new volume based on the contents of the specified data source. When the AnyVolumeDataSource feature gate is enabled, dataSource contents will be copied to dataSourceRef, and dataSourceRef contents will be copied to dataSource when dataSourceRef.namespace is not specified. If the namespace is specified, then dataSourceRef will not be copied to dataSource.

| `dataSourceRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.TypedObjectReference[`TypedObjectReference`]
| dataSourceRef specifies the object from which to populate the volume with data, if a non-empty volume is desired. This may be any object from a non-empty API group (non core object) or a PersistentVolumeClaim object. When this field is specified, volume binding will only succeed if the type of the specified object matches some installed volume populator or dynamic provisioner. This field will replace the functionality of the dataSource field and as such if both fields are non-empty, they must have the same value. For backwards compatibility, when namespace isn't specified in dataSourceRef, both fields (dataSource and dataSourceRef) will be set to the same value automatically if one of them is empty and the other is non-empty. When namespace is specified in dataSourceRef, dataSource isn't set to the same value and must be empty. There are three important differences between dataSource and dataSourceRef: * While dataSource only allows two specific types of objects, dataSourceRef
  allows any non-core object, as well as PersistentVolumeClaim objects.
* While dataSource ignores disallowed values (dropping them), dataSourceRef
  preserves all values, and generates an error if a disallowed value is
  specified.
* While dataSource only allows local objects, dataSourceRef allows objects
  in any namespaces.
(Beta) Using this field requires the AnyVolumeDataSource feature gate to be enabled. (Alpha) Using the namespace field of dataSourceRef requires the CrossNamespaceVolumeDataSource feature gate to be enabled.

| `resources`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ResourceRequirements[`ResourceRequirements`]
| resources represents the minimum resources the volume should have. If RecoverVolumeExpansionFailure feature is enabled users are allowed to specify resource requirements that are lower than previous value but must still be higher than capacity recorded in the status field of the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#resources

| `selector`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.LabelSelector[`LabelSelector`]
| selector is a label query over volumes to consider for binding.

| `storageClassName`
| `string`
| storageClassName is the name of the StorageClass required by the claim. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#class-1

| `volumeMode`
| `string`
| volumeMode defines what type of volume is required by the claim. Value of Filesystem is implied when not included in claim spec.

Possible enum values:
 - `"Block"` means the volume will not be formatted with a filesystem and will remain a raw block device.
 - `"Filesystem"` means the volume will be or is formatted with a filesystem.

| `volumeName`
| `string`
| volumeName is the binding reference to the PersistentVolume backing this claim.

|===

[id="io.k8s.api.core.v1.PersistentVolumeClaimTemplate"]
== io.k8s.api.core.v1.PersistentVolumeClaimTemplate schema


Description::
+
--
PersistentVolumeClaimTemplate is used to produce PersistentVolumeClaim objects as part of an EphemeralVolumeSource.
--

Type::
  `object`

Required::
  - `spec`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta[`ObjectMeta`]
| May contain labels and annotations that will be copied into the PVC when creating it. No other fields are allowed and will be rejected during validation.

| `spec`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PersistentVolumeClaimSpec[`PersistentVolumeClaimSpec`]
| The specification for the PersistentVolumeClaim. The entire content is copied unchanged into the PVC that gets created from this template. The same fields as in a PersistentVolumeClaim are also valid here.

|===

[id="io.k8s.api.core.v1.PersistentVolumeClaimVolumeSource"]
== io.k8s.api.core.v1.PersistentVolumeClaimVolumeSource schema


Description::
+
--
PersistentVolumeClaimVolumeSource references the user's PVC in the same namespace. This volume finds the bound PV and mounts that volume for the pod. A PersistentVolumeClaimVolumeSource is, essentially, a wrapper around another type of volume that is owned by someone else (the system).
--

Type::
  `object`

Required::
  - `claimName`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `claimName`
| `string`
| claimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

| `readOnly`
| `boolean`
| readOnly Will force the ReadOnly setting in VolumeMounts. Default false.

|===

[id="io.k8s.api.core.v1.PersistentVolumeList"]
== io.k8s.api.core.v1.PersistentVolumeList schema


Description::
+
--
PersistentVolumeList is a list of PersistentVolume items.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/persistentvolume-v1.adoc#persistentvolume-v1[`array (PersistentVolume)`]
| items is a list of persistent volumes. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.PersistentVolumeSpec"]
== io.k8s.api.core.v1.PersistentVolumeSpec schema


Description::
+
--
PersistentVolumeSpec is the specification of a persistent volume.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `accessModes`
| `array (string)`
| accessModes contains all ways the volume can be mounted. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#access-modes

| `awsElasticBlockStore`
| xref:../objects/index.adoc#io.k8s.api.core.v1.AWSElasticBlockStoreVolumeSource[`AWSElasticBlockStoreVolumeSource`]
| awsElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

| `azureDisk`
| xref:../objects/index.adoc#io.k8s.api.core.v1.AzureDiskVolumeSource[`AzureDiskVolumeSource`]
| azureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.

| `azureFile`
| xref:../objects/index.adoc#io.k8s.api.core.v1.AzureFilePersistentVolumeSource[`AzureFilePersistentVolumeSource`]
| azureFile represents an Azure File Service mount on the host and bind mount to the pod.

| `capacity`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.api.resource.Quantity[`object (Quantity)`]
| capacity is the description of the persistent volume's resources and capacity. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#capacity

| `cephfs`
| xref:../objects/index.adoc#io.k8s.api.core.v1.CephFSPersistentVolumeSource[`CephFSPersistentVolumeSource`]
| cephFS represents a Ceph FS mount on the host that shares a pod's lifetime

| `cinder`
| xref:../objects/index.adoc#io.k8s.api.core.v1.CinderPersistentVolumeSource[`CinderPersistentVolumeSource`]
| cinder represents a cinder volume attached and mounted on kubelets host machine. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

| `claimRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ObjectReference[`ObjectReference`]
| claimRef is part of a bi-directional binding between PersistentVolume and PersistentVolumeClaim. Expected to be non-nil when bound. claim.VolumeName is the authoritative bind between PV and PVC. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#binding

| `csi`
| xref:../objects/index.adoc#io.k8s.api.core.v1.CSIPersistentVolumeSource[`CSIPersistentVolumeSource`]
| csi represents storage that is handled by an external CSI driver (Beta feature).

| `fc`
| xref:../objects/index.adoc#io.k8s.api.core.v1.FCVolumeSource[`FCVolumeSource`]
| fc represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.

| `flexVolume`
| xref:../objects/index.adoc#io.k8s.api.core.v1.FlexPersistentVolumeSource[`FlexPersistentVolumeSource`]
| flexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.

| `flocker`
| xref:../objects/index.adoc#io.k8s.api.core.v1.FlockerVolumeSource[`FlockerVolumeSource`]
| flocker represents a Flocker volume attached to a kubelet's host machine and exposed to the pod for its usage. This depends on the Flocker control service being running

| `gcePersistentDisk`
| xref:../objects/index.adoc#io.k8s.api.core.v1.GCEPersistentDiskVolumeSource[`GCEPersistentDiskVolumeSource`]
| gcePersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. Provisioned by an admin. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

| `glusterfs`
| xref:../objects/index.adoc#io.k8s.api.core.v1.GlusterfsPersistentVolumeSource[`GlusterfsPersistentVolumeSource`]
| glusterfs represents a Glusterfs volume that is attached to a host and exposed to the pod. Provisioned by an admin. More info: https://examples.k8s.io/volumes/glusterfs/README.md

| `hostPath`
| xref:../objects/index.adoc#io.k8s.api.core.v1.HostPathVolumeSource[`HostPathVolumeSource`]
| hostPath represents a directory on the host. Provisioned by a developer or tester. This is useful for single-node development and testing only! On-host storage is not supported in any way and WILL NOT WORK in a multi-node cluster. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

| `iscsi`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ISCSIPersistentVolumeSource[`ISCSIPersistentVolumeSource`]
| iscsi represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. Provisioned by an admin.

| `local`
| xref:../objects/index.adoc#io.k8s.api.core.v1.LocalVolumeSource[`LocalVolumeSource`]
| local represents directly-attached storage with node affinity

| `mountOptions`
| `array (string)`
| mountOptions is the list of mount options, e.g. ["ro", "soft"]. Not validated - mount will simply fail if one is invalid. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes/#mount-options

| `nfs`
| xref:../objects/index.adoc#io.k8s.api.core.v1.NFSVolumeSource[`NFSVolumeSource`]
| nfs represents an NFS mount on the host. Provisioned by an admin. More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

| `nodeAffinity`
| xref:../objects/index.adoc#io.k8s.api.core.v1.VolumeNodeAffinity[`VolumeNodeAffinity`]
| nodeAffinity defines constraints that limit what nodes this volume can be accessed from. This field influences the scheduling of pods that use this volume.

| `persistentVolumeReclaimPolicy`
| `string`
| persistentVolumeReclaimPolicy defines what happens to a persistent volume when released from its claim. Valid options are Retain (default for manually created PersistentVolumes), Delete (default for dynamically provisioned PersistentVolumes), and Recycle (deprecated). Recycle must be supported by the volume plugin underlying this PersistentVolume. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#reclaiming

Possible enum values:
 - `"Delete"` means the volume will be deleted from Kubernetes on release from its claim. The volume plugin must support Deletion.
 - `"Recycle"` means the volume will be recycled back into the pool of unbound persistent volumes on release from its claim. The volume plugin must support Recycling.
 - `"Retain"` means the volume will be left in its current phase (Released) for manual reclamation by the administrator. The default policy is Retain.

| `photonPersistentDisk`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PhotonPersistentDiskVolumeSource[`PhotonPersistentDiskVolumeSource`]
| photonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine

| `portworxVolume`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PortworxVolumeSource[`PortworxVolumeSource`]
| portworxVolume represents a portworx volume attached and mounted on kubelets host machine

| `quobyte`
| xref:../objects/index.adoc#io.k8s.api.core.v1.QuobyteVolumeSource[`QuobyteVolumeSource`]
| quobyte represents a Quobyte mount on the host that shares a pod's lifetime

| `rbd`
| xref:../objects/index.adoc#io.k8s.api.core.v1.RBDPersistentVolumeSource[`RBDPersistentVolumeSource`]
| rbd represents a Rados Block Device mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/rbd/README.md

| `scaleIO`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ScaleIOPersistentVolumeSource[`ScaleIOPersistentVolumeSource`]
| scaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.

| `storageClassName`
| `string`
| storageClassName is the name of StorageClass to which this persistent volume belongs. Empty value means that this volume does not belong to any StorageClass.

| `storageos`
| xref:../objects/index.adoc#io.k8s.api.core.v1.StorageOSPersistentVolumeSource[`StorageOSPersistentVolumeSource`]
| storageOS represents a StorageOS volume that is attached to the kubelet's host machine and mounted into the pod More info: https://examples.k8s.io/volumes/storageos/README.md

| `volumeMode`
| `string`
| volumeMode defines if a volume is intended to be used with a formatted filesystem or to remain in raw block state. Value of Filesystem is implied when not included in spec.

Possible enum values:
 - `"Block"` means the volume will not be formatted with a filesystem and will remain a raw block device.
 - `"Filesystem"` means the volume will be or is formatted with a filesystem.

| `vsphereVolume`
| xref:../objects/index.adoc#io.k8s.api.core.v1.VsphereVirtualDiskVolumeSource[`VsphereVirtualDiskVolumeSource`]
| vsphereVolume represents a vSphere volume attached and mounted on kubelets host machine

|===

[id="io.k8s.api.core.v1.PhotonPersistentDiskVolumeSource"]
== io.k8s.api.core.v1.PhotonPersistentDiskVolumeSource schema


Description::
+
--
Represents a Photon Controller persistent disk resource.
--

Type::
  `object`

Required::
  - `pdID`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is the filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

| `pdID`
| `string`
| pdID is the ID that identifies Photon Controller persistent disk

|===

[id="io.k8s.api.core.v1.PodAffinity"]
== io.k8s.api.core.v1.PodAffinity schema


Description::
+
--
Pod affinity is a group of inter pod affinity scheduling rules.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `preferredDuringSchedulingIgnoredDuringExecution`
| xref:../objects/index.adoc#io.k8s.api.core.v1.WeightedPodAffinityTerm[`array (WeightedPodAffinityTerm)`]
| The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.

| `requiredDuringSchedulingIgnoredDuringExecution`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodAffinityTerm[`array (PodAffinityTerm)`]
| If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.

|===

[id="io.k8s.api.core.v1.PodAffinityTerm"]
== io.k8s.api.core.v1.PodAffinityTerm schema


Description::
+
--
Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> matches that of any node on which a pod of the set of pods is running
--

Type::
  `object`

Required::
  - `topologyKey`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `labelSelector`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.LabelSelector[`LabelSelector`]
| A label query over a set of resources, in this case pods.

| `namespaceSelector`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.LabelSelector[`LabelSelector`]
| A label query over the set of namespaces that the term applies to. The term is applied to the union of the namespaces selected by this field and the ones listed in the namespaces field. null selector and null or empty namespaces list means "this pod's namespace". An empty selector ({}) matches all namespaces.

| `namespaces`
| `array (string)`
| namespaces specifies a static list of namespace names that the term applies to. The term is applied to the union of the namespaces listed in this field and the ones selected by namespaceSelector. null or empty namespaces list and null namespaceSelector means "this pod's namespace".

| `topologyKey`
| `string`
| This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. Empty topologyKey is not allowed.

|===

[id="io.k8s.api.core.v1.PodAntiAffinity"]
== io.k8s.api.core.v1.PodAntiAffinity schema


Description::
+
--
Pod anti affinity is a group of inter pod anti affinity scheduling rules.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `preferredDuringSchedulingIgnoredDuringExecution`
| xref:../objects/index.adoc#io.k8s.api.core.v1.WeightedPodAffinityTerm[`array (WeightedPodAffinityTerm)`]
| The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred.

| `requiredDuringSchedulingIgnoredDuringExecution`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodAffinityTerm[`array (PodAffinityTerm)`]
| If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied.

|===

[id="io.k8s.api.core.v1.PodDNSConfig"]
== io.k8s.api.core.v1.PodDNSConfig schema


Description::
+
--
PodDNSConfig defines the DNS parameters of a pod in addition to those generated from DNSPolicy.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `nameservers`
| `array (string)`
| A list of DNS name server IP addresses. This will be appended to the base nameservers generated from DNSPolicy. Duplicated nameservers will be removed.

| `options`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodDNSConfigOption[`array (PodDNSConfigOption)`]
| A list of DNS resolver options. This will be merged with the base options generated from DNSPolicy. Duplicated entries will be removed. Resolution options given in Options will override those that appear in the base DNSPolicy.

| `searches`
| `array (string)`
| A list of DNS search domains for host-name lookup. This will be appended to the base search paths generated from DNSPolicy. Duplicated search paths will be removed.

|===

[id="io.k8s.api.core.v1.PodDNSConfigOption"]
== io.k8s.api.core.v1.PodDNSConfigOption schema


Description::
+
--
PodDNSConfigOption defines DNS resolver options of a pod.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| Required.

| `value`
| `string`
|

|===

[id="io.k8s.api.core.v1.PodList"]
== io.k8s.api.core.v1.PodList schema


Description::
+
--
PodList is a list of Pods.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/pod-v1.adoc#pod-v1[`array (Pod)`]
| List of pods. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.PodOS"]
== io.k8s.api.core.v1.PodOS schema


Description::
+
--
PodOS defines the OS parameters of a pod.
--

Type::
  `object`

Required::
  - `name`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| Name is the name of the operating system. The currently supported values are linux and windows. Additional value may be defined in future and can be one of: https://github.com/opencontainers/runtime-spec/blob/master/config.md#platform-specific-configuration Clients should expect to handle additional values and treat unrecognized values in this field as os: null

|===

[id="io.k8s.api.core.v1.PodReadinessGate"]
== io.k8s.api.core.v1.PodReadinessGate schema


Description::
+
--
PodReadinessGate contains the reference to a pod condition
--

Type::
  `object`

Required::
  - `conditionType`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `conditionType`
| `string`
| ConditionType refers to a condition in the pod's condition list with matching type.

|===

[id="io.k8s.api.core.v1.PodResourceClaim"]
== io.k8s.api.core.v1.PodResourceClaim schema


Description::
+
--
PodResourceClaim references exactly one ResourceClaim through a ClaimSource. It adds a name to it that uniquely identifies the ResourceClaim inside the Pod. Containers that need access to the ResourceClaim reference it with this name.
--

Type::
  `object`

Required::
  - `name`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| Name uniquely identifies this resource claim inside the pod. This must be a DNS_LABEL.

| `source`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ClaimSource[`ClaimSource`]
| Source describes where to find the ResourceClaim.

|===

[id="io.k8s.api.core.v1.PodSchedulingGate"]
== io.k8s.api.core.v1.PodSchedulingGate schema


Description::
+
--
PodSchedulingGate is associated to a Pod to guard its scheduling.
--

Type::
  `object`

Required::
  - `name`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| Name of the scheduling gate. Each scheduling gate must have a unique name field.

|===

[id="io.k8s.api.core.v1.PodSecurityContext"]
== io.k8s.api.core.v1.PodSecurityContext schema


Description::
+
--
PodSecurityContext holds pod-level security attributes and common container settings. Some fields are also present in container.securityContext.  Field values of container.securityContext take precedence over field values of PodSecurityContext.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsGroup`
| `integer`
| A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod:

1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR'd with rw-rw----

If unset, the Kubelet will not modify the ownership and permissions of any volume. Note that this field cannot be set when spec.os.name is windows.

| `fsGroupChangePolicy`
| `string`
| fsGroupChangePolicy defines behavior of changing ownership and permission of the volume before being exposed inside Pod. This field will only apply to volume types which support fsGroup based ownership(and permissions). It will have no effect on ephemeral volume types such as: secret, configmaps and emptydir. Valid values are "OnRootMismatch" and "Always". If not specified, "Always" is used. Note that this field cannot be set when spec.os.name is windows.

Possible enum values:
 - `"Always"` indicates that volume's ownership and permissions should always be changed whenever volume is mounted inside a Pod. This the default behavior.
 - `"OnRootMismatch"` indicates that volume's ownership and permissions will be changed only when permission and ownership of root directory does not match with expected permissions on the volume. This can help shorten the time it takes to change ownership and permissions of a volume.

| `runAsGroup`
| `integer`
| The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.

| `runAsNonRoot`
| `boolean`
| Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.

| `runAsUser`
| `integer`
| The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.

| `seLinuxOptions`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SELinuxOptions[`SELinuxOptions`]
| The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in SecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. Note that this field cannot be set when spec.os.name is windows.

| `seccompProfile`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SeccompProfile[`SeccompProfile`]
| The seccomp options to use by the containers in this pod. Note that this field cannot be set when spec.os.name is windows.

| `supplementalGroups`
| `array (integer)`
| A list of groups applied to the first process run in each container, in addition to the container's primary GID, the fsGroup (if specified), and group memberships defined in the container image for the uid of the container process. If unspecified, no additional groups are added to any container. Note that group memberships defined in the container image for the uid of the container process are still effective, even if they are not included in this list. Note that this field cannot be set when spec.os.name is windows.

| `sysctls`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Sysctl[`array (Sysctl)`]
| Sysctls hold a list of namespaced sysctls used for the pod. Pods with unsupported sysctls (by the container runtime) might fail to launch. Note that this field cannot be set when spec.os.name is windows.

| `windowsOptions`
| xref:../objects/index.adoc#io.k8s.api.core.v1.WindowsSecurityContextOptions[`WindowsSecurityContextOptions`]
| The Windows specific settings applied to all containers. If unspecified, the options within a container's SecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.

|===

[id="io.k8s.api.core.v1.PodSpec"]
== io.k8s.api.core.v1.PodSpec schema


Description::
+
--
PodSpec is a description of a pod.
--

Type::
  `object`

Required::
  - `containers`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `activeDeadlineSeconds`
| `integer`
| Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer.

| `affinity`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Affinity[`Affinity`]
| If specified, the pod's scheduling constraints

| `automountServiceAccountToken`
| `boolean`
| AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.

| `containers`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Container[`array (Container)`]
| List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated.

| `dnsConfig`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodDNSConfig[`PodDNSConfig`]
| Specifies the DNS parameters of a pod. Parameters specified here will be merged to the generated DNS configuration based on DNSPolicy.

| `dnsPolicy`
| `string`
| Set DNS policy for the pod. Defaults to "ClusterFirst". Valid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'. DNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy. To have DNS options set along with hostNetwork, you have to specify DNS policy explicitly to 'ClusterFirstWithHostNet'.

Possible enum values:
 - `"ClusterFirst"` indicates that the pod should use cluster DNS first unless hostNetwork is true, if it is available, then fall back on the default (as determined by kubelet) DNS settings.
 - `"ClusterFirstWithHostNet"` indicates that the pod should use cluster DNS first, if it is available, then fall back on the default (as determined by kubelet) DNS settings.
 - `"Default"` indicates that the pod should use the default (as determined by kubelet) DNS settings.
 - `"None"` indicates that the pod should use empty DNS settings. DNS parameters such as nameservers and search paths should be defined via DNSConfig.

| `enableServiceLinks`
| `boolean`
| EnableServiceLinks indicates whether information about services should be injected into pod's environment variables, matching the syntax of Docker links. Optional: Defaults to true.

| `ephemeralContainers`
| xref:../objects/index.adoc#io.k8s.api.core.v1.EphemeralContainer[`array (EphemeralContainer)`]
| List of ephemeral containers run in this pod. Ephemeral containers may be run in an existing pod to perform user-initiated actions such as debugging. This list cannot be specified when creating a pod, and it cannot be modified by updating the pod spec. In order to add an ephemeral container to an existing pod, use the pod's ephemeralcontainers subresource.

| `hostAliases`
| xref:../objects/index.adoc#io.k8s.api.core.v1.HostAlias[`array (HostAlias)`]
| HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts file if specified. This is only valid for non-hostNetwork pods.

| `hostIPC`
| `boolean`
| Use the host's ipc namespace. Optional: Default to false.

| `hostNetwork`
| `boolean`
| Host networking requested for this pod. Use the host's network namespace. If this option is set, the ports that will be used must be specified. Default to false.

| `hostPID`
| `boolean`
| Use the host's pid namespace. Optional: Default to false.

| `hostUsers`
| `boolean`
| Use the host's user namespace. Optional: Default to true. If set to true or not present, the pod will be run in the host user namespace, useful for when the pod needs a feature only available to the host user namespace, such as loading a kernel module with CAP_SYS_MODULE. When set to false, a new userns is created for the pod. Setting false is useful for mitigating container breakout vulnerabilities even allowing users to run their containers as root without actually having root privileges on the host. This field is alpha-level and is only honored by servers that enable the UserNamespacesSupport feature.

| `hostname`
| `string`
| Specifies the hostname of the Pod If not specified, the pod's hostname will be set to a system-defined value.

| `imagePullSecrets`
| xref:../objects/index.adoc#io.k8s.api.core.v1.LocalObjectReference[`array (LocalObjectReference)`]
| ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. More info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod

| `initContainers`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Container[`array (Container)`]
| List of initialization containers belonging to the pod. Init containers are executed in order prior to containers being started. If any init container fails, the pod is considered to have failed and is handled according to its restartPolicy. The name for an init container or normal container must be unique among all containers. Init containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes. The resourceRequirements of an init container are taken into account during scheduling by finding the highest request/limit for each resource type, and then using the max of of that value or the sum of the normal containers. Limits are applied to init containers in a similar fashion. Init containers cannot currently be added or removed. Cannot be updated. More info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/

| `nodeName`
| `string`
| NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements.

| `nodeSelector`
| `object (string)`
| NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node's labels for the pod to be scheduled on that node. More info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/

| `os`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodOS[`PodOS`]
| Specifies the OS of the containers in the pod. Some pod and container fields are restricted if this is set.

If the OS field is set to linux, the following fields must be unset: -securityContext.windowsOptions

If the OS field is set to windows, following fields must be unset: - spec.hostPID - spec.hostIPC - spec.hostUsers - spec.securityContext.seLinuxOptions - spec.securityContext.seccompProfile - spec.securityContext.fsGroup - spec.securityContext.fsGroupChangePolicy - spec.securityContext.sysctls - spec.shareProcessNamespace - spec.securityContext.runAsUser - spec.securityContext.runAsGroup - spec.securityContext.supplementalGroups - spec.containers[*].securityContext.seLinuxOptions - spec.containers[*].securityContext.seccompProfile - spec.containers[*].securityContext.capabilities - spec.containers[*].securityContext.readOnlyRootFilesystem - spec.containers[*].securityContext.privileged - spec.containers[*].securityContext.allowPrivilegeEscalation - spec.containers[*].securityContext.procMount - spec.containers[*].securityContext.runAsUser - spec.containers[*].securityContext.runAsGroup

| `overhead`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.api.resource.Quantity[`object (Quantity)`]
| Overhead represents the resource overhead associated with running a pod for a given RuntimeClass. This field will be autopopulated at admission time by the RuntimeClass admission controller. If the RuntimeClass admission controller is enabled, overhead must not be set in Pod create requests. The RuntimeClass admission controller will reject Pod create requests which have the overhead already set. If RuntimeClass is configured and selected in the PodSpec, Overhead will be set to the value defined in the corresponding RuntimeClass, otherwise it will remain unset and treated as zero. More info: https://git.k8s.io/enhancements/keps/sig-node/688-pod-overhead/README.md

| `preemptionPolicy`
| `string`
| PreemptionPolicy is the Policy for preempting pods with lower priority. One of Never, PreemptLowerPriority. Defaults to PreemptLowerPriority if unset.

Possible enum values:
 - `"Never"` means that pod never preempts other pods with lower priority.
 - `"PreemptLowerPriority"` means that pod can preempt other pods with lower priority.

| `priority`
| `integer`
| The priority value. Various system components use this field to find the priority of the pod. When Priority Admission Controller is enabled, it prevents users from setting this field. The admission controller populates this field from PriorityClassName. The higher the value, the higher the priority.

| `priorityClassName`
| `string`
| If specified, indicates the pod's priority. "system-node-critical" and "system-cluster-critical" are two special keywords which indicate the highest priorities with the former being the highest priority. Any other name must be defined by creating a PriorityClass object with that name. If not specified, the pod priority will be default or zero if there is no default.

| `readinessGates`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodReadinessGate[`array (PodReadinessGate)`]
| If specified, all readiness gates will be evaluated for pod readiness. A pod is ready when all its containers are ready AND all conditions specified in the readiness gates have status equal to "True" More info: https://git.k8s.io/enhancements/keps/sig-network/580-pod-readiness-gates

| `resourceClaims`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodResourceClaim[`array (PodResourceClaim)`]
| ResourceClaims defines which ResourceClaims must be allocated and reserved before the Pod is allowed to start. The resources will be made available to those containers which consume them by name.

This is an alpha field and requires enabling the DynamicResourceAllocation feature gate.

This field is immutable.

| `restartPolicy`
| `string`
| Restart policy for all containers within the pod. One of Always, OnFailure, Never. In some contexts, only a subset of those values may be permitted. Default to Always. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy

Possible enum values:
 - `"Always"`
 - `"Never"`
 - `"OnFailure"`

| `runtimeClassName`
| `string`
| RuntimeClassName refers to a RuntimeClass object in the node.k8s.io group, which should be used to run this pod.  If no RuntimeClass resource matches the named class, the pod will not be run. If unset or empty, the "legacy" RuntimeClass will be used, which is an implicit class with an empty definition that uses the default runtime handler. More info: https://git.k8s.io/enhancements/keps/sig-node/585-runtime-class

| `schedulerName`
| `string`
| If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler.

| `schedulingGates`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodSchedulingGate[`array (PodSchedulingGate)`]
| SchedulingGates is an opaque list of values that if specified will block scheduling the pod. If schedulingGates is not empty, the pod will stay in the SchedulingGated state and the scheduler will not attempt to schedule the pod.

SchedulingGates can only be set at pod creation time, and be removed only afterwards.

This is a beta feature enabled by the PodSchedulingReadiness feature gate.

| `securityContext`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodSecurityContext[`PodSecurityContext`]
| SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty.  See type description for default values of each field.

| `serviceAccount`
| `string`
| DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead.

| `serviceAccountName`
| `string`
| ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/

| `setHostnameAsFQDN`
| `boolean`
| If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default). In Linux containers, this means setting the FQDN in the hostname field of the kernel (the nodename field of struct utsname). In Windows containers, this means setting the registry value of hostname for the registry key HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters to FQDN. If a pod does not have FQDN, this has no effect. Default to false.

| `shareProcessNamespace`
| `boolean`
| Share a single process namespace between all of the containers in a pod. When this is set containers will be able to view and signal processes from other containers in the same pod, and the first process in each container will not be assigned PID 1. HostPID and ShareProcessNamespace cannot both be set. Optional: Default to false.

| `subdomain`
| `string`
| If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>". If not specified, the pod will not have a domainname at all.

| `terminationGracePeriodSeconds`
| `integer`
| Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds.

| `tolerations`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Toleration[`array (Toleration)`]
| If specified, the pod's tolerations.

| `topologySpreadConstraints`
| xref:../objects/index.adoc#io.k8s.api.core.v1.TopologySpreadConstraint[`array (TopologySpreadConstraint)`]
| TopologySpreadConstraints describes how a group of pods ought to spread across topology domains. Scheduler will schedule pods in a way which abides by the constraints. All topologySpreadConstraints are ANDed.

| `volumes`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Volume[`array (Volume)`]
| List of volumes that can be mounted by containers belonging to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes

|===

[id="io.k8s.api.core.v1.PodTemplateList"]
== io.k8s.api.core.v1.PodTemplateList schema


Description::
+
--
PodTemplateList is a list of PodTemplates.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/podtemplate-v1.adoc#podtemplate-v1[`array (PodTemplate)`]
| List of pod templates

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.PodTemplateSpec"]
== io.k8s.api.core.v1.PodTemplateSpec schema


Description::
+
--
PodTemplateSpec describes the data a pod should have when created from a template
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta[`ObjectMeta`]
| Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

| `spec`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodSpec[`PodSpec`]
| Specification of the desired behavior of the pod. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

|===

[id="io.k8s.api.core.v1.PortworxVolumeSource"]
== io.k8s.api.core.v1.PortworxVolumeSource schema


Description::
+
--
PortworxVolumeSource represents a Portworx volume resource.
--

Type::
  `object`

Required::
  - `volumeID`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fSType represents the filesystem type to mount Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs". Implicitly inferred to be "ext4" if unspecified.

| `readOnly`
| `boolean`
| readOnly defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

| `volumeID`
| `string`
| volumeID uniquely identifies a Portworx volume

|===

[id="io.k8s.api.core.v1.PreferredSchedulingTerm"]
== io.k8s.api.core.v1.PreferredSchedulingTerm schema


Description::
+
--
An empty preferred scheduling term matches all objects with implicit weight 0 (i.e. it's a no-op). A null preferred scheduling term matches no objects (i.e. is also a no-op).
--

Type::
  `object`

Required::
  - `weight`
  - `preference`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `preference`
| xref:../objects/index.adoc#io.k8s.api.core.v1.NodeSelectorTerm[`NodeSelectorTerm`]
| A node selector term, associated with the corresponding weight.

| `weight`
| `integer`
| Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100.

|===

[id="io.k8s.api.core.v1.Probe"]
== io.k8s.api.core.v1.Probe schema


Description::
+
--
Probe describes a health check to be performed against a container to determine whether it is alive or ready to receive traffic.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `exec`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ExecAction[`ExecAction`]
| Exec specifies the action to take.

| `failureThreshold`
| `integer`
| Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1.

| `grpc`
| xref:../objects/index.adoc#io.k8s.api.core.v1.GRPCAction[`GRPCAction`]
| GRPC specifies an action involving a GRPC port.

| `httpGet`
| xref:../objects/index.adoc#io.k8s.api.core.v1.HTTPGetAction[`HTTPGetAction`]
| HTTPGet specifies the http request to perform.

| `initialDelaySeconds`
| `integer`
| Number of seconds after the container has started before liveness probes are initiated. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

| `periodSeconds`
| `integer`
| How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1.

| `successThreshold`
| `integer`
| Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness and startup. Minimum value is 1.

| `tcpSocket`
| xref:../objects/index.adoc#io.k8s.api.core.v1.TCPSocketAction[`TCPSocketAction`]
| TCPSocket specifies an action involving a TCP port.

| `terminationGracePeriodSeconds`
| `integer`
| Optional duration in seconds the pod needs to terminate gracefully upon probe failure. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. If this value is nil, the pod's terminationGracePeriodSeconds will be used. Otherwise, this value overrides the value provided by the pod spec. Value must be non-negative integer. The value zero indicates stop immediately via the kill signal (no opportunity to shut down). This is a beta field and requires enabling ProbeTerminationGracePeriod feature gate. Minimum value is 1. spec.terminationGracePeriodSeconds is used if unset.

| `timeoutSeconds`
| `integer`
| Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle#container-probes

|===

[id="io.k8s.api.core.v1.ProjectedVolumeSource"]
== io.k8s.api.core.v1.ProjectedVolumeSource schema


Description::
+
--
Represents a projected volume source
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `defaultMode`
| `integer`
| defaultMode are the mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

| `sources`
| xref:../objects/index.adoc#io.k8s.api.core.v1.VolumeProjection[`array (VolumeProjection)`]
| sources is the list of volume projections

|===

[id="io.k8s.api.core.v1.QuobyteVolumeSource"]
== io.k8s.api.core.v1.QuobyteVolumeSource schema


Description::
+
--
Represents a Quobyte mount that lasts the lifetime of a pod. Quobyte volumes do not support ownership management or SELinux relabeling.
--

Type::
  `object`

Required::
  - `registry`
  - `volume`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `group`
| `string`
| group to map volume access to Default is no group

| `readOnly`
| `boolean`
| readOnly here will force the Quobyte volume to be mounted with read-only permissions. Defaults to false.

| `registry`
| `string`
| registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes

| `tenant`
| `string`
| tenant owning the given Quobyte volume in the Backend Used with dynamically provisioned Quobyte volumes, value is set by the plugin

| `user`
| `string`
| user to map volume access to Defaults to serivceaccount user

| `volume`
| `string`
| volume is a string that references an already created Quobyte volume by name.

|===

[id="io.k8s.api.core.v1.RBDPersistentVolumeSource"]
== io.k8s.api.core.v1.RBDPersistentVolumeSource schema


Description::
+
--
Represents a Rados Block Device mount that lasts the lifetime of a pod. RBD volumes support ownership management and SELinux relabeling.
--

Type::
  `object`

Required::
  - `monitors`
  - `image`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is the filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd

| `image`
| `string`
| image is the rados image name. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

| `keyring`
| `string`
| keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

| `monitors`
| `array (string)`
| monitors is a collection of Ceph monitors. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

| `pool`
| `string`
| pool is the rados pool name. Default is rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

| `readOnly`
| `boolean`
| readOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretReference[`SecretReference`]
| secretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

| `user`
| `string`
| user is the rados user name. Default is admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

|===

[id="io.k8s.api.core.v1.RBDVolumeSource"]
== io.k8s.api.core.v1.RBDVolumeSource schema


Description::
+
--
Represents a Rados Block Device mount that lasts the lifetime of a pod. RBD volumes support ownership management and SELinux relabeling.
--

Type::
  `object`

Required::
  - `monitors`
  - `image`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is the filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: https://kubernetes.io/docs/concepts/storage/volumes#rbd

| `image`
| `string`
| image is the rados image name. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

| `keyring`
| `string`
| keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

| `monitors`
| `array (string)`
| monitors is a collection of Ceph monitors. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

| `pool`
| `string`
| pool is the rados pool name. Default is rbd. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

| `readOnly`
| `boolean`
| readOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.LocalObjectReference[`LocalObjectReference`]
| secretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

| `user`
| `string`
| user is the rados user name. Default is admin. More info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it

|===

[id="io.k8s.api.core.v1.ReplicationControllerList"]
== io.k8s.api.core.v1.ReplicationControllerList schema


Description::
+
--
ReplicationControllerList is a collection of replication controllers.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/replicationcontroller-v1.adoc#replicationcontroller-v1[`array (ReplicationController)`]
| List of replication controllers. More info: https://kubernetes.io/docs/concepts/workloads/controllers/replicationcontroller

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.ResourceClaim"]
== io.k8s.api.core.v1.ResourceClaim schema


Description::
+
--
ResourceClaim references one entry in PodSpec.ResourceClaims.
--

Type::
  `object`

Required::
  - `name`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| Name must match the name of one entry in pod.spec.resourceClaims of the Pod where this field is used. It makes that resource available inside a container.

|===

[id="io.k8s.api.core.v1.ResourceFieldSelector"]
== io.k8s.api.core.v1.ResourceFieldSelector schema


Description::
+
--
ResourceFieldSelector represents container resources (cpu, memory) and their output format
--

Type::
  `object`

Required::
  - `resource`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `containerName`
| `string`
| Container name: required for volumes, optional for env vars

| `divisor`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.api.resource.Quantity[`Quantity`]
| Specifies the output format of the exposed resources, defaults to "1"

| `resource`
| `string`
| Required: resource to select

|===

[id="io.k8s.api.core.v1.ResourceQuotaList"]
== io.k8s.api.core.v1.ResourceQuotaList schema


Description::
+
--
ResourceQuotaList is a list of ResourceQuota items.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/resourcequota-v1.adoc#resourcequota-v1[`array (ResourceQuota)`]
| Items is a list of ResourceQuota objects. More info: https://kubernetes.io/docs/concepts/policy/resource-quotas/

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.ResourceRequirements"]
== io.k8s.api.core.v1.ResourceRequirements schema


Description::
+
--
ResourceRequirements describes the compute resource requirements.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `claims`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ResourceClaim[`array (ResourceClaim)`]
| Claims lists the names of resources, defined in spec.resourceClaims, that are used by this container.

This is an alpha field and requires enabling the DynamicResourceAllocation feature gate.

This field is immutable. It can only be set for containers.

| `limits`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.api.resource.Quantity[`object (Quantity)`]
| Limits describes the maximum amount of compute resources allowed. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

| `requests`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.api.resource.Quantity[`object (Quantity)`]
| Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. Requests cannot exceed Limits. More info: https://kubernetes.io/docs/concepts/configuration/manage-resources-containers/

|===

[id="io.k8s.api.core.v1.ScaleIOPersistentVolumeSource"]
== io.k8s.api.core.v1.ScaleIOPersistentVolumeSource schema


Description::
+
--
ScaleIOPersistentVolumeSource represents a persistent ScaleIO volume
--

Type::
  `object`

Required::
  - `gateway`
  - `system`
  - `secretRef`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is the filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Default is "xfs"

| `gateway`
| `string`
| gateway is the host address of the ScaleIO API Gateway.

| `protectionDomain`
| `string`
| protectionDomain is the name of the ScaleIO Protection Domain for the configured storage.

| `readOnly`
| `boolean`
| readOnly defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretReference[`SecretReference`]
| secretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.

| `sslEnabled`
| `boolean`
| sslEnabled is the flag to enable/disable SSL communication with Gateway, default false

| `storageMode`
| `string`
| storageMode indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned. Default is ThinProvisioned.

| `storagePool`
| `string`
| storagePool is the ScaleIO Storage Pool associated with the protection domain.

| `system`
| `string`
| system is the name of the storage system as configured in ScaleIO.

| `volumeName`
| `string`
| volumeName is the name of a volume already created in the ScaleIO system that is associated with this volume source.

|===

[id="io.k8s.api.core.v1.ScaleIOVolumeSource"]
== io.k8s.api.core.v1.ScaleIOVolumeSource schema


Description::
+
--
ScaleIOVolumeSource represents a persistent ScaleIO volume
--

Type::
  `object`

Required::
  - `gateway`
  - `system`
  - `secretRef`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is the filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Default is "xfs".

| `gateway`
| `string`
| gateway is the host address of the ScaleIO API Gateway.

| `protectionDomain`
| `string`
| protectionDomain is the name of the ScaleIO Protection Domain for the configured storage.

| `readOnly`
| `boolean`
| readOnly Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.LocalObjectReference[`LocalObjectReference`]
| secretRef references to the secret for ScaleIO user and other sensitive information. If this is not provided, Login operation will fail.

| `sslEnabled`
| `boolean`
| sslEnabled Flag enable/disable SSL communication with Gateway, default false

| `storageMode`
| `string`
| storageMode indicates whether the storage for a volume should be ThickProvisioned or ThinProvisioned. Default is ThinProvisioned.

| `storagePool`
| `string`
| storagePool is the ScaleIO Storage Pool associated with the protection domain.

| `system`
| `string`
| system is the name of the storage system as configured in ScaleIO.

| `volumeName`
| `string`
| volumeName is the name of a volume already created in the ScaleIO system that is associated with this volume source.

|===

[id="io.k8s.api.core.v1.SeccompProfile"]
== io.k8s.api.core.v1.SeccompProfile schema


Description::
+
--
SeccompProfile defines a pod/container's seccomp profile settings. Only one profile source may be set.
--

Type::
  `object`

Required::
  - `type`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `localhostProfile`
| `string`
| localhostProfile indicates a profile defined in a file on the node should be used. The profile must be preconfigured on the node to work. Must be a descending path, relative to the kubelet's configured seccomp profile location. Must only be set if type is "Localhost".

| `type`
| `string`
| type indicates which kind of seccomp profile will be applied. Valid options are:

Localhost - a profile defined in a file on the node should be used. RuntimeDefault - the container runtime default profile should be used. Unconfined - no profile should be applied.

Possible enum values:
 - `"Localhost"` indicates a profile defined in a file on the node should be used. The file's location relative to <kubelet-root-dir>/seccomp.
 - `"RuntimeDefault"` represents the default container runtime seccomp profile.
 - `"Unconfined"` indicates no seccomp profile is applied (A.K.A. unconfined).

|===

[id="io.k8s.api.core.v1.SecretEnvSource"]
== io.k8s.api.core.v1.SecretEnvSource schema


Description::
+
--
SecretEnvSource selects a Secret to populate the environment variables with.

The contents of the target Secret's Data field will represent the key-value pairs as environment variables.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

| `optional`
| `boolean`
| Specify whether the Secret must be defined

|===

[id="io.k8s.api.core.v1.SecretKeySelector"]
== io.k8s.api.core.v1.SecretKeySelector schema


Description::
+
--
SecretKeySelector selects a key of a Secret.
--

Type::
  `object`

Required::
  - `key`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `key`
| `string`
| The key of the secret to select from.  Must be a valid secret key.

| `name`
| `string`
| Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

| `optional`
| `boolean`
| Specify whether the Secret or its key must be defined

|===

[id="io.k8s.api.core.v1.SecretList"]
== io.k8s.api.core.v1.SecretList schema


Description::
+
--
SecretList is a list of Secret.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/secret-v1.adoc#secret-v1[`array (Secret)`]
| Items is a list of secret objects. More info: https://kubernetes.io/docs/concepts/configuration/secret

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.SecretProjection"]
== io.k8s.api.core.v1.SecretProjection schema


Description::
+
--
Adapts a secret into a projected volume.

The contents of the target Secret's Data field will be presented in a projected volume as files using the keys in the Data field as the file names. Note that this is identical to a secret volume source without the default mode.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `items`
| xref:../objects/index.adoc#io.k8s.api.core.v1.KeyToPath[`array (KeyToPath)`]
| items if unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.

| `name`
| `string`
| Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

| `optional`
| `boolean`
| optional field specify whether the Secret or its key must be defined

|===

[id="io.k8s.api.core.v1.SecretReference"]
== io.k8s.api.core.v1.SecretReference schema


Description::
+
--
SecretReference represents a Secret Reference. It has enough information to retrieve secret in any namespace
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| name is unique within a namespace to reference a secret resource.

| `namespace`
| `string`
| namespace defines the space within which the secret name must be unique.

|===

[id="io.k8s.api.core.v1.SecretVolumeSource"]
== io.k8s.api.core.v1.SecretVolumeSource schema


Description::
+
--
Adapts a Secret into a volume.

The contents of the target Secret's Data field will be presented in a volume as files using the keys in the Data field as the file names. Secret volumes support ownership management and SELinux relabeling.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `defaultMode`
| `integer`
| defaultMode is Optional: mode bits used to set permissions on created files by default. Must be an octal value between 0000 and 0777 or a decimal value between 0 and 511. YAML accepts both octal and decimal values, JSON requires decimal values for mode bits. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set.

| `items`
| xref:../objects/index.adoc#io.k8s.api.core.v1.KeyToPath[`array (KeyToPath)`]
| items If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the '..' path or start with '..'.

| `optional`
| `boolean`
| optional field specify whether the Secret or its keys must be defined

| `secretName`
| `string`
| secretName is the name of the secret in the pod's namespace to use. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret

|===

[id="io.k8s.api.core.v1.SecurityContext"]
== io.k8s.api.core.v1.SecurityContext schema


Description::
+
--
SecurityContext holds security configuration that will be applied to a container. Some fields are present in both SecurityContext and PodSecurityContext.  When both are set, the values in SecurityContext take precedence.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `allowPrivilegeEscalation`
| `boolean`
| AllowPrivilegeEscalation controls whether a process can gain more privileges than its parent process. This bool directly controls if the no_new_privs flag will be set on the container process. AllowPrivilegeEscalation is true always when the container is: 1) run as Privileged 2) has CAP_SYS_ADMIN Note that this field cannot be set when spec.os.name is windows.

| `capabilities`
| xref:../objects/index.adoc#io.k8s.api.core.v1.Capabilities[`Capabilities`]
| The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. Note that this field cannot be set when spec.os.name is windows.

| `privileged`
| `boolean`
| Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. Note that this field cannot be set when spec.os.name is windows.

| `procMount`
| `string`
| procMount denotes the type of proc mount to use for the containers. The default is DefaultProcMount which uses the container runtime defaults for readonly paths and masked paths. This requires the ProcMountType feature flag to be enabled. Note that this field cannot be set when spec.os.name is windows.

Possible enum values:
 - `"Default"` uses the container runtime defaults for readonly and masked paths for /proc. Most container runtimes mask certain paths in /proc to avoid accidental security exposure of special devices or information.
 - `"Unmasked"` bypasses the default masking behavior of the container runtime and ensures the newly created /proc the container stays in tact with no modifications.

| `readOnlyRootFilesystem`
| `boolean`
| Whether this container has a read-only root filesystem. Default is false. Note that this field cannot be set when spec.os.name is windows.

| `runAsGroup`
| `integer`
| The GID to run the entrypoint of the container process. Uses runtime default if unset. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.

| `runAsNonRoot`
| `boolean`
| Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.

| `runAsUser`
| `integer`
| The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.

| `seLinuxOptions`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SELinuxOptions[`SELinuxOptions`]
| The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container.  May also be set in PodSecurityContext.  If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is windows.

| `seccompProfile`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SeccompProfile[`SeccompProfile`]
| The seccomp options to use by this container. If seccomp options are provided at both the pod & container level, the container options override the pod options. Note that this field cannot be set when spec.os.name is windows.

| `windowsOptions`
| xref:../objects/index.adoc#io.k8s.api.core.v1.WindowsSecurityContextOptions[`WindowsSecurityContextOptions`]
| The Windows specific settings applied to all containers. If unspecified, the options from the PodSecurityContext will be used. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. Note that this field cannot be set when spec.os.name is linux.

|===

[id="io.k8s.api.core.v1.SELinuxOptions"]
== io.k8s.api.core.v1.SELinuxOptions schema


Description::
+
--
SELinuxOptions are the labels to be applied to the container
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `level`
| `string`
| Level is SELinux level label that applies to the container.

| `role`
| `string`
| Role is a SELinux role label that applies to the container.

| `type`
| `string`
| Type is a SELinux type label that applies to the container.

| `user`
| `string`
| User is a SELinux user label that applies to the container.

|===

[id="io.k8s.api.core.v1.ServiceAccountList"]
== io.k8s.api.core.v1.ServiceAccountList schema


Description::
+
--
ServiceAccountList is a list of ServiceAccount objects
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/serviceaccount-v1.adoc#serviceaccount-v1[`array (ServiceAccount)`]
| List of ServiceAccounts. More info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.ServiceAccountTokenProjection"]
== io.k8s.api.core.v1.ServiceAccountTokenProjection schema


Description::
+
--
ServiceAccountTokenProjection represents a projected service account token volume. This projection can be used to insert a service account token into the pods runtime filesystem for use against APIs (Kubernetes API Server or otherwise).
--

Type::
  `object`

Required::
  - `path`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `audience`
| `string`
| audience is the intended audience of the token. A recipient of a token must identify itself with an identifier specified in the audience of the token, and otherwise should reject the token. The audience defaults to the identifier of the apiserver.

| `expirationSeconds`
| `integer`
| expirationSeconds is the requested duration of validity of the service account token. As the token approaches expiration, the kubelet volume plugin will proactively rotate the service account token. The kubelet will start trying to rotate the token if the token is older than 80 percent of its time to live or if the token is older than 24 hours.Defaults to 1 hour and must be at least 10 minutes.

| `path`
| `string`
| path is the path relative to the mount point of the file to project the token into.

|===

[id="io.k8s.api.core.v1.ServiceList"]
== io.k8s.api.core.v1.ServiceList schema


Description::
+
--
ServiceList holds a list of services.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../core_apis/service-v1.adoc#service-v1[`array (Service)`]
| List of services

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.api.core.v1.StorageOSPersistentVolumeSource"]
== io.k8s.api.core.v1.StorageOSPersistentVolumeSource schema


Description::
+
--
Represents a StorageOS persistent volume resource.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is the filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

| `readOnly`
| `boolean`
| readOnly defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ObjectReference[`ObjectReference`]
| secretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.

| `volumeName`
| `string`
| volumeName is the human-readable name of the StorageOS volume.  Volume names are only unique within a namespace.

| `volumeNamespace`
| `string`
| volumeNamespace specifies the scope of the volume within StorageOS.  If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to "default" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.

|===

[id="io.k8s.api.core.v1.StorageOSVolumeSource"]
== io.k8s.api.core.v1.StorageOSVolumeSource schema


Description::
+
--
Represents a StorageOS persistent volume resource.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is the filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

| `readOnly`
| `boolean`
| readOnly defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts.

| `secretRef`
| xref:../objects/index.adoc#io.k8s.api.core.v1.LocalObjectReference[`LocalObjectReference`]
| secretRef specifies the secret to use for obtaining the StorageOS API credentials.  If not specified, default values will be attempted.

| `volumeName`
| `string`
| volumeName is the human-readable name of the StorageOS volume.  Volume names are only unique within a namespace.

| `volumeNamespace`
| `string`
| volumeNamespace specifies the scope of the volume within StorageOS.  If no namespace is specified then the Pod's namespace will be used.  This allows the Kubernetes name scoping to be mirrored within StorageOS for tighter integration. Set VolumeName to any name to override the default behaviour. Set to "default" if you are not using namespaces within StorageOS. Namespaces that do not pre-exist within StorageOS will be created.

|===

[id="io.k8s.api.core.v1.Sysctl"]
== io.k8s.api.core.v1.Sysctl schema


Description::
+
--
Sysctl defines a kernel parameter to be set
--

Type::
  `object`

Required::
  - `name`
  - `value`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `name`
| `string`
| Name of a property to set

| `value`
| `string`
| Value of a property to set

|===

[id="io.k8s.api.core.v1.TCPSocketAction"]
== io.k8s.api.core.v1.TCPSocketAction schema


Description::
+
--
TCPSocketAction describes an action based on opening a socket
--

Type::
  `object`

Required::
  - `port`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `host`
| `string`
| Optional: Host name to connect to, defaults to the pod IP.

| `port`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.util.intstr.IntOrString[`IntOrString`]
| Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME.

|===

[id="io.k8s.api.core.v1.Toleration"]
== io.k8s.api.core.v1.Toleration schema


Description::
+
--
The pod this Toleration is attached to tolerates any taint that matches the triple <key,value,effect> using the matching operator <operator>.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `effect`
| `string`
| Effect indicates the taint effect to match. Empty means match all taint effects. When specified, allowed values are NoSchedule, PreferNoSchedule and NoExecute.

Possible enum values:
 - `"NoExecute"` Evict any already-running pods that do not tolerate the taint. Currently enforced by NodeController.
 - `"NoSchedule"` Do not allow new pods to schedule onto the node unless they tolerate the taint, but allow all pods submitted to Kubelet without going through the scheduler to start, and allow all already-running pods to continue running. Enforced by the scheduler.
 - `"PreferNoSchedule"` Like TaintEffectNoSchedule, but the scheduler tries not to schedule new pods onto the node, rather than prohibiting new pods from scheduling onto the node entirely. Enforced by the scheduler.

| `key`
| `string`
| Key is the taint key that the toleration applies to. Empty means match all taint keys. If the key is empty, operator must be Exists; this combination means to match all values and all keys.

| `operator`
| `string`
| Operator represents a key's relationship to the value. Valid operators are Exists and Equal. Defaults to Equal. Exists is equivalent to wildcard for value, so that a pod can tolerate all taints of a particular category.

Possible enum values:
 - `"Equal"`
 - `"Exists"`

| `tolerationSeconds`
| `integer`
| TolerationSeconds represents the period of time the toleration (which must be of effect NoExecute, otherwise this field is ignored) tolerates the taint. By default, it is not set, which means tolerate the taint forever (do not evict). Zero and negative values will be treated as 0 (evict immediately) by the system.

| `value`
| `string`
| Value is the taint value the toleration matches to. If the operator is Exists, the value should be empty, otherwise just a regular string.

|===

[id="io.k8s.api.core.v1.TopologySelectorLabelRequirement"]
== io.k8s.api.core.v1.TopologySelectorLabelRequirement schema


Description::
+
--
A topology selector requirement is a selector that matches given label. This is an alpha feature and may change in the future.
--

Type::
  `object`

Required::
  - `key`
  - `values`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `key`
| `string`
| The label key that the selector applies to.

| `values`
| `array (string)`
| An array of string values. One value must match the label to be selected. Each entry in Values is ORed.

|===

[id="io.k8s.api.core.v1.TopologySelectorTerm"]
== io.k8s.api.core.v1.TopologySelectorTerm schema


Description::
+
--
A topology selector term represents the result of label queries. A null or empty topology selector term matches no objects. The requirements of them are ANDed. It provides a subset of functionality as NodeSelectorTerm. This is an alpha feature and may change in the future.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `matchLabelExpressions`
| xref:../objects/index.adoc#io.k8s.api.core.v1.TopologySelectorLabelRequirement[`array (TopologySelectorLabelRequirement)`]
| A list of topology selector requirements by labels.

|===

[id="io.k8s.api.core.v1.TopologySpreadConstraint"]
== io.k8s.api.core.v1.TopologySpreadConstraint schema


Description::
+
--
TopologySpreadConstraint specifies how to spread matching pods among the given topology.
--

Type::
  `object`

Required::
  - `maxSkew`
  - `topologyKey`
  - `whenUnsatisfiable`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `labelSelector`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.LabelSelector[`LabelSelector`]
| LabelSelector is used to find matching pods. Pods that match this label selector are counted to determine the number of pods in their corresponding topology domain.

| `matchLabelKeys`
| `array (string)`
| MatchLabelKeys is a set of pod label keys to select the pods over which spreading will be calculated. The keys are used to lookup values from the incoming pod labels, those key-value labels are ANDed with labelSelector to select the group of existing pods over which spreading will be calculated for the incoming pod. The same key is forbidden to exist in both MatchLabelKeys and LabelSelector. MatchLabelKeys cannot be set when LabelSelector isn't set. Keys that don't exist in the incoming pod labels will be ignored. A null or empty list means only match against labelSelector.

This is a beta field and requires the MatchLabelKeysInPodTopologySpread feature gate to be enabled (enabled by default).

| `maxSkew`
| `integer`
| MaxSkew describes the degree to which pods may be unevenly distributed. When `whenUnsatisfiable=DoNotSchedule`, it is the maximum permitted difference between the number of matching pods in the target topology and the global minimum. The global minimum is the minimum number of matching pods in an eligible domain or zero if the number of eligible domains is less than MinDomains. For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same labelSelector spread as 2/2/1: In this case, the global minimum is 1. \| zone1 \| zone2 \| zone3 \| \|  P P  \|  P P  \|   P   \| - if MaxSkew is 1, incoming pod can only be scheduled to zone3 to become 2/2/2; scheduling it onto zone1(zone2) would make the ActualSkew(3-1) on zone1(zone2) violate MaxSkew(1). - if MaxSkew is 2, incoming pod can be scheduled onto any zone. When `whenUnsatisfiable=ScheduleAnyway`, it is used to give higher precedence to topologies that satisfy it. It's a required field. Default value is 1 and 0 is not allowed.

| `minDomains`
| `integer`
| MinDomains indicates a minimum number of eligible domains. When the number of eligible domains with matching topology keys is less than minDomains, Pod Topology Spread treats "global minimum" as 0, and then the calculation of Skew is performed. And when the number of eligible domains with matching topology keys equals or greater than minDomains, this value has no effect on scheduling. As a result, when the number of eligible domains is less than minDomains, scheduler won't schedule more than maxSkew Pods to those domains. If value is nil, the constraint behaves as if MinDomains is equal to 1. Valid values are integers greater than 0. When value is not nil, WhenUnsatisfiable must be DoNotSchedule.

For example, in a 3-zone cluster, MaxSkew is set to 2, MinDomains is set to 5 and pods with the same labelSelector spread as 2/2/2: \| zone1 \| zone2 \| zone3 \| \|  P P  \|  P P  \|  P P  \| The number of domains is less than 5(MinDomains), so "global minimum" is treated as 0. In this situation, new pod with the same labelSelector cannot be scheduled, because computed skew will be 3(3 - 0) if new Pod is scheduled to any of the three zones, it will violate MaxSkew.

This is a beta field and requires the MinDomainsInPodTopologySpread feature gate to be enabled (enabled by default).

| `nodeAffinityPolicy`
| `string`
| NodeAffinityPolicy indicates how we will treat Pod's nodeAffinity/nodeSelector when calculating pod topology spread skew. Options are: - Honor: only nodes matching nodeAffinity/nodeSelector are included in the calculations. - Ignore: nodeAffinity/nodeSelector are ignored. All nodes are included in the calculations.

If this value is nil, the behavior is equivalent to the Honor policy. This is a beta-level feature default enabled by the NodeInclusionPolicyInPodTopologySpread feature flag.

Possible enum values:
 - `"Honor"` means use this scheduling directive when calculating pod topology spread skew.
 - `"Ignore"` means ignore this scheduling directive when calculating pod topology spread skew.

| `nodeTaintsPolicy`
| `string`
| NodeTaintsPolicy indicates how we will treat node taints when calculating pod topology spread skew. Options are: - Honor: nodes without taints, along with tainted nodes for which the incoming pod has a toleration, are included. - Ignore: node taints are ignored. All nodes are included.

If this value is nil, the behavior is equivalent to the Ignore policy. This is a beta-level feature default enabled by the NodeInclusionPolicyInPodTopologySpread feature flag.

Possible enum values:
 - `"Honor"` means use this scheduling directive when calculating pod topology spread skew.
 - `"Ignore"` means ignore this scheduling directive when calculating pod topology spread skew.

| `topologyKey`
| `string`
| TopologyKey is the key of node labels. Nodes that have a label with this key and identical values are considered to be in the same topology. We consider each <key, value> as a "bucket", and try to put balanced number of pods into each bucket. We define a domain as a particular instance of a topology. Also, we define an eligible domain as a domain whose nodes meet the requirements of nodeAffinityPolicy and nodeTaintsPolicy. e.g. If TopologyKey is "kubernetes.io/hostname", each Node is a domain of that topology. And, if TopologyKey is "topology.kubernetes.io/zone", each zone is a domain of that topology. It's a required field.

| `whenUnsatisfiable`
| `string`
| WhenUnsatisfiable indicates how to deal with a pod if it doesn't satisfy the spread constraint. - DoNotSchedule (default) tells the scheduler not to schedule it. - ScheduleAnyway tells the scheduler to schedule the pod in any location,
  but giving higher precedence to topologies that would help reduce the
  skew.
A constraint is considered "Unsatisfiable" for an incoming pod if and only if every possible node assignment for that pod would violate "MaxSkew" on some topology. For example, in a 3-zone cluster, MaxSkew is set to 1, and pods with the same labelSelector spread as 3/1/1: \| zone1 \| zone2 \| zone3 \| \| P P P \|   P   \|   P   \| If WhenUnsatisfiable is set to DoNotSchedule, incoming pod can only be scheduled to zone2(zone3) to become 3/2/1(3/1/2) as ActualSkew(2-1) on zone2(zone3) satisfies MaxSkew(1). In other words, the cluster can still be imbalanced, but scheduler won't make it *more* imbalanced. It's a required field.

Possible enum values:
 - `"DoNotSchedule"` instructs the scheduler not to schedule the pod when constraints are not satisfied.
 - `"ScheduleAnyway"` instructs the scheduler to schedule the pod even if constraints are not satisfied.

|===

[id="io.k8s.api.core.v1.TypedLocalObjectReference"]
== io.k8s.api.core.v1.TypedLocalObjectReference schema


Description::
+
--
TypedLocalObjectReference contains enough information to let you locate the typed referenced object inside the same namespace.
--

Type::
  `object`

Required::
  - `kind`
  - `name`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiGroup`
| `string`
| APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.

| `kind`
| `string`
| Kind is the type of resource being referenced

| `name`
| `string`
| Name is the name of resource being referenced

|===

[id="io.k8s.api.core.v1.TypedObjectReference"]
== io.k8s.api.core.v1.TypedObjectReference schema


Description::
+
--

--

Type::
  `object`

Required::
  - `kind`
  - `name`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiGroup`
| `string`
| APIGroup is the group for the resource being referenced. If APIGroup is not specified, the specified Kind must be in the core API group. For any other third-party types, APIGroup is required.

| `kind`
| `string`
| Kind is the type of resource being referenced

| `name`
| `string`
| Name is the name of resource being referenced

| `namespace`
| `string`
| Namespace is the namespace of resource being referenced Note that when a namespace is specified, a gateway.networking.k8s.io/ReferenceGrant object is required in the referent namespace to allow that namespace's owner to accept the reference. See the ReferenceGrant documentation for details. (Alpha) This field requires the CrossNamespaceVolumeDataSource feature gate to be enabled.

|===

[id="io.k8s.api.core.v1.Volume"]
== io.k8s.api.core.v1.Volume schema


Description::
+
--
Volume represents a named volume in a pod that may be accessed by any container in the pod.
--

Type::
  `object`

Required::
  - `name`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `awsElasticBlockStore`
| xref:../objects/index.adoc#io.k8s.api.core.v1.AWSElasticBlockStoreVolumeSource[`AWSElasticBlockStoreVolumeSource`]
| awsElasticBlockStore represents an AWS Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore

| `azureDisk`
| xref:../objects/index.adoc#io.k8s.api.core.v1.AzureDiskVolumeSource[`AzureDiskVolumeSource`]
| azureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.

| `azureFile`
| xref:../objects/index.adoc#io.k8s.api.core.v1.AzureFileVolumeSource[`AzureFileVolumeSource`]
| azureFile represents an Azure File Service mount on the host and bind mount to the pod.

| `cephfs`
| xref:../objects/index.adoc#io.k8s.api.core.v1.CephFSVolumeSource[`CephFSVolumeSource`]
| cephFS represents a Ceph FS mount on the host that shares a pod's lifetime

| `cinder`
| xref:../objects/index.adoc#io.k8s.api.core.v1.CinderVolumeSource[`CinderVolumeSource`]
| cinder represents a cinder volume attached and mounted on kubelets host machine. More info: https://examples.k8s.io/mysql-cinder-pd/README.md

| `configMap`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ConfigMapVolumeSource[`ConfigMapVolumeSource`]
| configMap represents a configMap that should populate this volume

| `csi`
| xref:../objects/index.adoc#io.k8s.api.core.v1.CSIVolumeSource[`CSIVolumeSource`]
| csi (Container Storage Interface) represents ephemeral storage that is handled by certain external CSI drivers (Beta feature).

| `downwardAPI`
| xref:../objects/index.adoc#io.k8s.api.core.v1.DownwardAPIVolumeSource[`DownwardAPIVolumeSource`]
| downwardAPI represents downward API about the pod that should populate this volume

| `emptyDir`
| xref:../objects/index.adoc#io.k8s.api.core.v1.EmptyDirVolumeSource[`EmptyDirVolumeSource`]
| emptyDir represents a temporary directory that shares a pod's lifetime. More info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir

| `ephemeral`
| xref:../objects/index.adoc#io.k8s.api.core.v1.EphemeralVolumeSource[`EphemeralVolumeSource`]
| ephemeral represents a volume that is handled by a cluster storage driver. The volume's lifecycle is tied to the pod that defines it - it will be created before the pod starts, and deleted when the pod is removed.

Use this if: a) the volume is only needed while the pod runs, b) features of normal volumes like restoring from snapshot or capacity
   tracking are needed,
c) the storage driver is specified through a storage class, and d) the storage driver supports dynamic volume provisioning through
   a PersistentVolumeClaim (see EphemeralVolumeSource for more
   information on the connection between this volume type
   and PersistentVolumeClaim).

Use PersistentVolumeClaim or one of the vendor-specific APIs for volumes that persist for longer than the lifecycle of an individual pod.

Use CSI for light-weight local ephemeral volumes if the CSI driver is meant to be used that way - see the documentation of the driver for more information.

A pod can use both types of ephemeral volumes and persistent volumes at the same time.

| `fc`
| xref:../objects/index.adoc#io.k8s.api.core.v1.FCVolumeSource[`FCVolumeSource`]
| fc represents a Fibre Channel resource that is attached to a kubelet's host machine and then exposed to the pod.

| `flexVolume`
| xref:../objects/index.adoc#io.k8s.api.core.v1.FlexVolumeSource[`FlexVolumeSource`]
| flexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin.

| `flocker`
| xref:../objects/index.adoc#io.k8s.api.core.v1.FlockerVolumeSource[`FlockerVolumeSource`]
| flocker represents a Flocker volume attached to a kubelet's host machine. This depends on the Flocker control service being running

| `gcePersistentDisk`
| xref:../objects/index.adoc#io.k8s.api.core.v1.GCEPersistentDiskVolumeSource[`GCEPersistentDiskVolumeSource`]
| gcePersistentDisk represents a GCE Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk

| `gitRepo`
| xref:../objects/index.adoc#io.k8s.api.core.v1.GitRepoVolumeSource[`GitRepoVolumeSource`]
| gitRepo represents a git repository at a particular revision. DEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an EmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir into the Pod's container.

| `glusterfs`
| xref:../objects/index.adoc#io.k8s.api.core.v1.GlusterfsVolumeSource[`GlusterfsVolumeSource`]
| glusterfs represents a Glusterfs mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/glusterfs/README.md

| `hostPath`
| xref:../objects/index.adoc#io.k8s.api.core.v1.HostPathVolumeSource[`HostPathVolumeSource`]
| hostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container. This is generally used for system agents or other privileged things that are allowed to see the host machine. Most containers will NOT need this. More info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath

| `iscsi`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ISCSIVolumeSource[`ISCSIVolumeSource`]
| iscsi represents an ISCSI Disk resource that is attached to a kubelet's host machine and then exposed to the pod. More info: https://examples.k8s.io/volumes/iscsi/README.md

| `name`
| `string`
| name of the volume. Must be a DNS_LABEL and unique within the pod. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names

| `nfs`
| xref:../objects/index.adoc#io.k8s.api.core.v1.NFSVolumeSource[`NFSVolumeSource`]
| nfs represents an NFS mount on the host that shares a pod's lifetime More info: https://kubernetes.io/docs/concepts/storage/volumes#nfs

| `persistentVolumeClaim`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PersistentVolumeClaimVolumeSource[`PersistentVolumeClaimVolumeSource`]
| persistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. More info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims

| `photonPersistentDisk`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PhotonPersistentDiskVolumeSource[`PhotonPersistentDiskVolumeSource`]
| photonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine

| `portworxVolume`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PortworxVolumeSource[`PortworxVolumeSource`]
| portworxVolume represents a portworx volume attached and mounted on kubelets host machine

| `projected`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ProjectedVolumeSource[`ProjectedVolumeSource`]
| projected items for all in one resources secrets, configmaps, and downward API

| `quobyte`
| xref:../objects/index.adoc#io.k8s.api.core.v1.QuobyteVolumeSource[`QuobyteVolumeSource`]
| quobyte represents a Quobyte mount on the host that shares a pod's lifetime

| `rbd`
| xref:../objects/index.adoc#io.k8s.api.core.v1.RBDVolumeSource[`RBDVolumeSource`]
| rbd represents a Rados Block Device mount on the host that shares a pod's lifetime. More info: https://examples.k8s.io/volumes/rbd/README.md

| `scaleIO`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ScaleIOVolumeSource[`ScaleIOVolumeSource`]
| scaleIO represents a ScaleIO persistent volume attached and mounted on Kubernetes nodes.

| `secret`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretVolumeSource[`SecretVolumeSource`]
| secret represents a secret that should populate this volume. More info: https://kubernetes.io/docs/concepts/storage/volumes#secret

| `storageos`
| xref:../objects/index.adoc#io.k8s.api.core.v1.StorageOSVolumeSource[`StorageOSVolumeSource`]
| storageOS represents a StorageOS volume attached and mounted on Kubernetes nodes.

| `vsphereVolume`
| xref:../objects/index.adoc#io.k8s.api.core.v1.VsphereVirtualDiskVolumeSource[`VsphereVirtualDiskVolumeSource`]
| vsphereVolume represents a vSphere volume attached and mounted on kubelets host machine

|===

[id="io.k8s.api.core.v1.VolumeDevice"]
== io.k8s.api.core.v1.VolumeDevice schema


Description::
+
--
volumeDevice describes a mapping of a raw block device within a container.
--

Type::
  `object`

Required::
  - `name`
  - `devicePath`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `devicePath`
| `string`
| devicePath is the path inside of the container that the device will be mapped to.

| `name`
| `string`
| name must match the name of a persistentVolumeClaim in the pod

|===

[id="io.k8s.api.core.v1.VolumeMount"]
== io.k8s.api.core.v1.VolumeMount schema


Description::
+
--
VolumeMount describes a mounting of a Volume within a container.
--

Type::
  `object`

Required::
  - `name`
  - `mountPath`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `mountPath`
| `string`
| Path within the container at which the volume should be mounted.  Must not contain ':'.

| `mountPropagation`
| `string`
| mountPropagation determines how mounts are propagated from the host to container and the other way around. When not set, MountPropagationNone is used. This field is beta in 1.10.

Possible enum values:
 - `"Bidirectional"` means that the volume in a container will receive new mounts from the host or other containers, and its own mounts will be propagated from the container to the host or other containers. Note that this mode is recursively applied to all mounts in the volume ("rshared" in Linux terminology).
 - `"HostToContainer"` means that the volume in a container will receive new mounts from the host or other containers, but filesystems mounted inside the container won't be propagated to the host or other containers. Note that this mode is recursively applied to all mounts in the volume ("rslave" in Linux terminology).
 - `"None"` means that the volume in a container will not receive new mounts from the host or other containers, and filesystems mounted inside the container won't be propagated to the host or other containers. Note that this mode corresponds to "private" in Linux terminology.

| `name`
| `string`
| This must match the Name of a Volume.

| `readOnly`
| `boolean`
| Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false.

| `subPath`
| `string`
| Path within the volume from which the container's volume should be mounted. Defaults to "" (volume's root).

| `subPathExpr`
| `string`
| Expanded path within the volume from which the container's volume should be mounted. Behaves similarly to SubPath but environment variable references $(VAR_NAME) are expanded using the container's environment. Defaults to "" (volume's root). SubPathExpr and SubPath are mutually exclusive.

|===

[id="io.k8s.api.core.v1.VolumeNodeAffinity"]
== io.k8s.api.core.v1.VolumeNodeAffinity schema


Description::
+
--
VolumeNodeAffinity defines constraints that limit what nodes this volume can be accessed from.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `required`
| xref:../objects/index.adoc#io.k8s.api.core.v1.NodeSelector[`NodeSelector`]
| required specifies hard node constraints that must be met.

|===

[id="io.k8s.api.core.v1.VolumeProjection"]
== io.k8s.api.core.v1.VolumeProjection schema


Description::
+
--
Projection that may be projected along with other supported volume types
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `configMap`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ConfigMapProjection[`ConfigMapProjection`]
| configMap information about the configMap data to project

| `downwardAPI`
| xref:../objects/index.adoc#io.k8s.api.core.v1.DownwardAPIProjection[`DownwardAPIProjection`]
| downwardAPI information about the downwardAPI data to project

| `secret`
| xref:../objects/index.adoc#io.k8s.api.core.v1.SecretProjection[`SecretProjection`]
| secret information about the secret data to project

| `serviceAccountToken`
| xref:../objects/index.adoc#io.k8s.api.core.v1.ServiceAccountTokenProjection[`ServiceAccountTokenProjection`]
| serviceAccountToken is information about the serviceAccountToken data to project

|===

[id="io.k8s.api.core.v1.VsphereVirtualDiskVolumeSource"]
== io.k8s.api.core.v1.VsphereVirtualDiskVolumeSource schema


Description::
+
--
Represents a vSphere volume resource.
--

Type::
  `object`

Required::
  - `volumePath`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `fsType`
| `string`
| fsType is filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified.

| `storagePolicyID`
| `string`
| storagePolicyID is the storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.

| `storagePolicyName`
| `string`
| storagePolicyName is the storage Policy Based Management (SPBM) profile name.

| `volumePath`
| `string`
| volumePath is the path that identifies vSphere volume vmdk

|===

[id="io.k8s.api.core.v1.WeightedPodAffinityTerm"]
== io.k8s.api.core.v1.WeightedPodAffinityTerm schema


Description::
+
--
The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)
--

Type::
  `object`

Required::
  - `weight`
  - `podAffinityTerm`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `podAffinityTerm`
| xref:../objects/index.adoc#io.k8s.api.core.v1.PodAffinityTerm[`PodAffinityTerm`]
| Required. A pod affinity term, associated with the corresponding weight.

| `weight`
| `integer`
| weight associated with matching the corresponding podAffinityTerm, in the range 1-100.

|===

[id="io.k8s.api.core.v1.WindowsSecurityContextOptions"]
== io.k8s.api.core.v1.WindowsSecurityContextOptions schema


Description::
+
--
WindowsSecurityContextOptions contain Windows-specific options and credentials.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `gmsaCredentialSpec`
| `string`
| GMSACredentialSpec is where the GMSA admission webhook (https://github.com/kubernetes-sigs/windows-gmsa) inlines the contents of the GMSA credential spec named by the GMSACredentialSpecName field.

| `gmsaCredentialSpecName`
| `string`
| GMSACredentialSpecName is the name of the GMSA credential spec to use.

| `hostProcess`
| `boolean`
| HostProcess determines if a container should be run as a 'Host Process' container. This field is alpha-level and will only be honored by components that enable the WindowsHostProcessContainers feature flag. Setting this field without the feature flag will result in errors when validating the Pod. All of a Pod's containers must have the same effective HostProcess value (it is not allowed to have a mix of HostProcess containers and non-HostProcess containers).  In addition, if HostProcess is true then HostNetwork must also be set to true.

| `runAsUserName`
| `string`
| The UserName in Windows to run the entrypoint of the container process. Defaults to the user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence.

|===

[id="io.k8s.api.discovery.v1.EndpointSliceList"]
== io.k8s.api.discovery.v1.EndpointSliceList schema


Description::
+
--
EndpointSliceList represents a list of endpoint slices
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../discovery_apis/endpointslice-discovery-k8s-io-v1.adoc#endpointslice-discovery-k8s-io-v1[`array (EndpointSlice)`]
| items is the list of endpoint slices

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata.

|===

[id="io.k8s.api.events.v1.EventList"]
== io.k8s.api.events.v1.EventList schema


Description::
+
--
EventList is a list of Event objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../events_apis/event-events-k8s-io-v1.adoc#event-events-k8s-io-v1[`array (Event)`]
| items is a list of schema objects.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.flowcontrol.v1beta3.FlowSchemaList"]
== io.k8s.api.flowcontrol.v1beta3.FlowSchemaList schema


Description::
+
--
FlowSchemaList is a list of FlowSchema objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../flow_control_apis/flowschema-flowcontrol-apiserver-k8s-io-v1beta3.adoc#flowschema-flowcontrol-apiserver-k8s-io-v1beta3[`array (FlowSchema)`]
| `items` is a list of FlowSchemas.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| `metadata` is the standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfigurationList"]
== io.k8s.api.flowcontrol.v1beta3.PriorityLevelConfigurationList schema


Description::
+
--
PriorityLevelConfigurationList is a list of PriorityLevelConfiguration objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../flow_control_apis/prioritylevelconfiguration-flowcontrol-apiserver-k8s-io-v1beta3.adoc#prioritylevelconfiguration-flowcontrol-apiserver-k8s-io-v1beta3[`array (PriorityLevelConfiguration)`]
| `items` is a list of request-priorities.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| `metadata` is the standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.networking.v1.IngressClassList"]
== io.k8s.api.networking.v1.IngressClassList schema


Description::
+
--
IngressClassList is a collection of IngressClasses.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../networking_apis/ingressclass-networking-k8s-io-v1.adoc#ingressclass-networking-k8s-io-v1[`array (IngressClass)`]
| items is the list of IngressClasses.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata.

|===

[id="io.k8s.api.networking.v1.IngressList"]
== io.k8s.api.networking.v1.IngressList schema


Description::
+
--
IngressList is a collection of Ingress.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../networking_apis/ingress-networking-k8s-io-v1.adoc#ingress-networking-k8s-io-v1[`array (Ingress)`]
| items is the list of Ingress.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.networking.v1.NetworkPolicyList"]
== io.k8s.api.networking.v1.NetworkPolicyList schema


Description::
+
--
NetworkPolicyList is a list of NetworkPolicy objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../networking_apis/networkpolicy-networking-k8s-io-v1.adoc#networkpolicy-networking-k8s-io-v1[`array (NetworkPolicy)`]
| items is a list of schema objects.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.node.v1.RuntimeClassList"]
== io.k8s.api.node.v1.RuntimeClassList schema


Description::
+
--
RuntimeClassList is a list of RuntimeClass objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../node_apis/runtimeclass-node-k8s-io-v1.adoc#runtimeclass-node-k8s-io-v1[`array (RuntimeClass)`]
| items is a list of schema objects.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.policy.v1.PodDisruptionBudgetList"]
== io.k8s.api.policy.v1.PodDisruptionBudgetList schema


Description::
+
--
PodDisruptionBudgetList is a collection of PodDisruptionBudgets.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../policy_apis/poddisruptionbudget-policy-v1.adoc#poddisruptionbudget-policy-v1[`array (PodDisruptionBudget)`]
| Items is a list of PodDisruptionBudgets

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard object's metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.rbac.v1.ClusterRoleBindingList"]
== io.k8s.api.rbac.v1.ClusterRoleBindingList schema


Description::
+
--
ClusterRoleBindingList is a collection of ClusterRoleBindings
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../rbac_apis/clusterrolebinding-rbac-authorization-k8s-io-v1.adoc#clusterrolebinding-rbac-authorization-k8s-io-v1[`array (ClusterRoleBinding)`]
| Items is a list of ClusterRoleBindings

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard object's metadata.

|===

[id="io.k8s.api.rbac.v1.ClusterRoleList"]
== io.k8s.api.rbac.v1.ClusterRoleList schema


Description::
+
--
ClusterRoleList is a collection of ClusterRoles
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../rbac_apis/clusterrole-rbac-authorization-k8s-io-v1.adoc#clusterrole-rbac-authorization-k8s-io-v1[`array (ClusterRole)`]
| Items is a list of ClusterRoles

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard object's metadata.

|===

[id="io.k8s.api.rbac.v1.RoleBindingList"]
== io.k8s.api.rbac.v1.RoleBindingList schema


Description::
+
--
RoleBindingList is a collection of RoleBindings
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../rbac_apis/rolebinding-rbac-authorization-k8s-io-v1.adoc#rolebinding-rbac-authorization-k8s-io-v1[`array (RoleBinding)`]
| Items is a list of RoleBindings

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard object's metadata.

|===

[id="io.k8s.api.rbac.v1.RoleList"]
== io.k8s.api.rbac.v1.RoleList schema


Description::
+
--
RoleList is a collection of Roles
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../rbac_apis/role-rbac-authorization-k8s-io-v1.adoc#role-rbac-authorization-k8s-io-v1[`array (Role)`]
| Items is a list of Roles

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard object's metadata.

|===

[id="io.k8s.api.scheduling.v1.PriorityClassList"]
== io.k8s.api.scheduling.v1.PriorityClassList schema


Description::
+
--
PriorityClassList is a collection of priority classes.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../scheduling_apis/priorityclass-scheduling-k8s-io-v1.adoc#priorityclass-scheduling-k8s-io-v1[`array (PriorityClass)`]
| items is the list of PriorityClasses

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.storage.v1.CSIDriverList"]
== io.k8s.api.storage.v1.CSIDriverList schema


Description::
+
--
CSIDriverList is a collection of CSIDriver objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../storage_apis/csidriver-storage-k8s-io-v1.adoc#csidriver-storage-k8s-io-v1[`array (CSIDriver)`]
| items is the list of CSIDriver

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.storage.v1.CSINodeList"]
== io.k8s.api.storage.v1.CSINodeList schema


Description::
+
--
CSINodeList is a collection of CSINode objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../storage_apis/csinode-storage-k8s-io-v1.adoc#csinode-storage-k8s-io-v1[`array (CSINode)`]
| items is the list of CSINode

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.storage.v1.CSIStorageCapacityList"]
== io.k8s.api.storage.v1.CSIStorageCapacityList schema


Description::
+
--
CSIStorageCapacityList is a collection of CSIStorageCapacity objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../storage_apis/csistoragecapacity-storage-k8s-io-v1.adoc#csistoragecapacity-storage-k8s-io-v1[`array (CSIStorageCapacity)`]
| items is the list of CSIStorageCapacity objects.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.storage.v1.StorageClassList"]
== io.k8s.api.storage.v1.StorageClassList schema


Description::
+
--
StorageClassList is a collection of storage classes.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../storage_apis/storageclass-storage-k8s-io-v1.adoc#storageclass-storage-k8s-io-v1[`array (StorageClass)`]
| items is the list of StorageClasses

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.api.storage.v1.VolumeAttachmentList"]
== io.k8s.api.storage.v1.VolumeAttachmentList schema


Description::
+
--
VolumeAttachmentList is a collection of VolumeAttachment objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../storage_apis/volumeattachment-storage-k8s-io-v1.adoc#volumeattachment-storage-k8s-io-v1[`array (VolumeAttachment)`]
| items is the list of VolumeAttachments

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinitionList"]
== io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.CustomResourceDefinitionList schema


Description::
+
--
CustomResourceDefinitionList is a list of CustomResourceDefinition objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../api_extensions_apis/customresourcedefinition-apiextensions-k8s-io-v1.adoc#customresourcedefinition-apiextensions-k8s-io-v1[`array (CustomResourceDefinition)`]
| items list individual CustomResourceDefinition objects

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard object's metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.ExternalDocumentation"]
== io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.ExternalDocumentation schema


Description::
+
--
ExternalDocumentation allows referencing an external resource for extended documentation.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `description`
| `string`
|

| `url`
| `string`
|

|===

[id="io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSON"]
== io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSON schema


Description::
+
--
JSON represents any valid JSON value. These types are supported: bool, int64, float64, string, []interface{}, map[string]interface{} and nil.
--

Type::
  ``



[id="io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaProps"]
== io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaProps schema


Description::
+
--
JSONSchemaProps is a JSON-Schema following Specification Draft 4 (http://json-schema.org/).
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `$ref`
| `string`
|

| `$schema`
| `string`
|

| `additionalItems`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaPropsOrBool[`JSONSchemaPropsOrBool`]
|

| `additionalProperties`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaPropsOrBool[`JSONSchemaPropsOrBool`]
|

| `allOf`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaProps[`array (undefined)`]
|

| `anyOf`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaProps[`array (undefined)`]
|

| `default`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSON[`JSON`]
| default is a default value for undefined object fields. Defaulting is a beta feature under the CustomResourceDefaulting feature gate. Defaulting requires spec.preserveUnknownFields to be false.

| `definitions`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaProps[`object (undefined)`]
|

| `dependencies`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaPropsOrStringArray[`object (undefined)`]
|

| `description`
| `string`
|

| `enum`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSON[`array (JSON)`]
|

| `example`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSON[`JSON`]
|

| `exclusiveMaximum`
| `boolean`
|

| `exclusiveMinimum`
| `boolean`
|

| `externalDocs`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.ExternalDocumentation[`ExternalDocumentation`]
|

| `format`
| `string`
| format is an OpenAPI v3 format string. Unknown formats are ignored. The following formats are validated:

- bsonobjectid: a bson object ID, i.e. a 24 characters hex string - uri: an URI as parsed by Golang net/url.ParseRequestURI - email: an email address as parsed by Golang net/mail.ParseAddress - hostname: a valid representation for an Internet host name, as defined by RFC 1034, section 3.1 [RFC1034]. - ipv4: an IPv4 IP as parsed by Golang net.ParseIP - ipv6: an IPv6 IP as parsed by Golang net.ParseIP - cidr: a CIDR as parsed by Golang net.ParseCIDR - mac: a MAC address as parsed by Golang net.ParseMAC - uuid: an UUID that allows uppercase defined by the regex (?i)^[0-9a-f]{8}-?[0-9a-f]{4}-?[0-9a-f]{4}-?[0-9a-f]{4}-?[0-9a-f]{12}$ - uuid3: an UUID3 that allows uppercase defined by the regex (?i)^[0-9a-f]{8}-?[0-9a-f]{4}-?3[0-9a-f]{3}-?[0-9a-f]{4}-?[0-9a-f]{12}$ - uuid4: an UUID4 that allows uppercase defined by the regex (?i)^[0-9a-f]{8}-?[0-9a-f]{4}-?4[0-9a-f]{3}-?[89ab][0-9a-f]{3}-?[0-9a-f]{12}$ - uuid5: an UUID5 that allows uppercase defined by the regex (?i)^[0-9a-f]{8}-?[0-9a-f]{4}-?5[0-9a-f]{3}-?[89ab][0-9a-f]{3}-?[0-9a-f]{12}$ - isbn: an ISBN10 or ISBN13 number string like "0321751043" or "978-0321751041" - isbn10: an ISBN10 number string like "0321751043" - isbn13: an ISBN13 number string like "978-0321751041" - creditcard: a credit card number defined by the regex ^(?:4[0-9]{12}(?:[0-9]{3})?\|5[1-5][0-9]{14}\|6(?:011\|5[0-9][0-9])[0-9]{12}\|3[47][0-9]{13}\|3(?:0[0-5]\|[68][0-9])[0-9]{11}\|(?:2131\|1800\|35\d{3})\d{11})$ with any non digit characters mixed in - ssn: a U.S. social security number following the regex ^\d{3}[- ]?\d{2}[- ]?\d{4}$ - hexcolor: an hexadecimal color code like "#FFFFFF: following the regex ^#?([0-9a-fA-F]{3}\|[0-9a-fA-F]{6})$ - rgbcolor: an RGB color code like rgb like "rgb(255,255,2559" - byte: base64 encoded binary data - password: any kind of string - date: a date string like "2006-01-02" as defined by full-date in RFC3339 - duration: a duration string like "22 ns" as parsed by Golang time.ParseDuration or compatible with Scala duration format - datetime: a date time string like "2014-12-15T19:30:20.000Z" as defined by date-time in RFC3339.

| `id`
| `string`
|

| `items`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaPropsOrArray[`JSONSchemaPropsOrArray`]
|

| `maxItems`
| `integer`
|

| `maxLength`
| `integer`
|

| `maxProperties`
| `integer`
|

| `maximum`
| `number`
|

| `minItems`
| `integer`
|

| `minLength`
| `integer`
|

| `minProperties`
| `integer`
|

| `minimum`
| `number`
|

| `multipleOf`
| `number`
|

| `not`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaProps[`JSONSchemaProps`]
|

| `nullable`
| `boolean`
|

| `oneOf`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaProps[`array (undefined)`]
|

| `pattern`
| `string`
|

| `patternProperties`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaProps[`object (undefined)`]
|

| `properties`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaProps[`object (undefined)`]
|

| `required`
| `array (string)`
|

| `title`
| `string`
|

| `type`
| `string`
|

| `uniqueItems`
| `boolean`
|

| `x-kubernetes-embedded-resource`
| `boolean`
| x-kubernetes-embedded-resource defines that the value is an embedded Kubernetes runtime.Object, with TypeMeta and ObjectMeta. The type must be object. It is allowed to further restrict the embedded object. kind, apiVersion and metadata are validated automatically. x-kubernetes-preserve-unknown-fields is allowed to be true, but does not have to be if the object is fully specified (up to kind, apiVersion, metadata).

| `x-kubernetes-int-or-string`
| `boolean`
| x-kubernetes-int-or-string specifies that this value is either an integer or a string. If this is true, an empty type is allowed and type as child of anyOf is permitted if following one of the following patterns:

1) anyOf:
   - type: integer
   - type: string
2) allOf:
   - anyOf:
     - type: integer
     - type: string
   - ... zero or more

| `x-kubernetes-list-map-keys`
| `array (string)`
| x-kubernetes-list-map-keys annotates an array with the x-kubernetes-list-type `map` by specifying the keys used as the index of the map.

This tag MUST only be used on lists that have the "x-kubernetes-list-type" extension set to "map". Also, the values specified for this attribute must be a scalar typed field of the child structure (no nesting is supported).

The properties specified must either be required or have a default value, to ensure those properties are present for all list items.

| `x-kubernetes-list-type`
| `string`
| x-kubernetes-list-type annotates an array to further describe its topology. This extension must only be used on lists and may have 3 possible values:

1) `atomic`: the list is treated as a single entity, like a scalar.
     Atomic lists will be entirely replaced when updated. This extension
     may be used on any type of list (struct, scalar, ...).
2) `set`:
     Sets are lists that must not have multiple items with the same value. Each
     value must be a scalar, an object with x-kubernetes-map-type `atomic` or an
     array with x-kubernetes-list-type `atomic`.
3) `map`:
     These lists are like maps in that their elements have a non-index key
     used to identify them. Order is preserved upon merge. The map tag
     must only be used on a list with elements of type object.
Defaults to atomic for arrays.

| `x-kubernetes-map-type`
| `string`
| x-kubernetes-map-type annotates an object to further describe its topology. This extension must only be used when type is object and may have 2 possible values:

1) `granular`:
     These maps are actual maps (key-value pairs) and each fields are independent
     from each other (they can each be manipulated by separate actors). This is
     the default behaviour for all maps.
2) `atomic`: the list is treated as a single entity, like a scalar.
     Atomic maps will be entirely replaced when updated.

| `x-kubernetes-preserve-unknown-fields`
| `boolean`
| x-kubernetes-preserve-unknown-fields stops the API server decoding step from pruning fields which are not specified in the validation schema. This affects fields recursively, but switches back to normal pruning behaviour if nested properties or additionalProperties are specified in the schema. This can either be true or undefined. False is forbidden.

| `x-kubernetes-validations`
| xref:../objects/index.adoc#io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.ValidationRule[`array (ValidationRule)`]
| x-kubernetes-validations describes a list of validation rules written in the CEL expression language. This field is an alpha-level. Using this field requires the feature gate `CustomResourceValidationExpressions` to be enabled.

|===

[id="io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaPropsOrArray"]
== io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaPropsOrArray schema


Description::
+
--
JSONSchemaPropsOrArray represents a value that can either be a JSONSchemaProps or an array of JSONSchemaProps. Mainly here for serialization purposes.
--

Type::
  ``



[id="io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaPropsOrBool"]
== io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaPropsOrBool schema


Description::
+
--
JSONSchemaPropsOrBool represents JSONSchemaProps or a boolean value. Defaults to true for the boolean property.
--

Type::
  ``



[id="io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaPropsOrStringArray"]
== io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.JSONSchemaPropsOrStringArray schema


Description::
+
--
JSONSchemaPropsOrStringArray represents a JSONSchemaProps or a string array.
--

Type::
  ``



[id="io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.ValidationRule"]
== io.k8s.apiextensions-apiserver.pkg.apis.apiextensions.v1.ValidationRule schema


Description::
+
--
ValidationRule describes a validation rule written in the CEL expression language.
--

Type::
  `object`

Required::
  - `rule`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `message`
| `string`
| Message represents the message displayed when validation fails. The message is required if the Rule contains line breaks. The message must not contain line breaks. If unset, the message is "failed rule: {Rule}". e.g. "must be a URL with the host matching spec.host"

| `messageExpression`
| `string`
| MessageExpression declares a CEL expression that evaluates to the validation failure message that is returned when this rule fails. Since messageExpression is used as a failure message, it must evaluate to a string. If both message and messageExpression are present on a rule, then messageExpression will be used if validation fails. If messageExpression results in a runtime error, the runtime error is logged, and the validation failure message is produced as if the messageExpression field were unset. If messageExpression evaluates to an empty string, a string with only spaces, or a string that contains line breaks, then the validation failure message will also be produced as if the messageExpression field were unset, and the fact that messageExpression produced an empty string/string with only spaces/string with line breaks will be logged. messageExpression has access to all the same variables as the rule; the only difference is the return type. Example: "x must be less than max ("+string(self.max)+")"

| `rule`
| `string`
| Rule represents the expression which will be evaluated by CEL. ref: https://github.com/google/cel-spec The Rule is scoped to the location of the x-kubernetes-validations extension in the schema. The `self` variable in the CEL expression is bound to the scoped value. Example: - Rule scoped to the root of a resource with a status subresource: {"rule": "self.status.actual <= self.spec.maxDesired"}

If the Rule is scoped to an object with properties, the accessible properties of the object are field selectable via `self.field` and field presence can be checked via `has(self.field)`. Null valued fields are treated as absent fields in CEL expressions. If the Rule is scoped to an object with additionalProperties (i.e. a map) the value of the map are accessible via `self[mapKey]`, map containment can be checked via `mapKey in self` and all entries of the map are accessible via CEL macros and functions such as `self.all(...)`. If the Rule is scoped to an array, the elements of the array are accessible via `self[i]` and also by macros and functions. If the Rule is scoped to a scalar, `self` is bound to the scalar value. Examples: - Rule scoped to a map of objects: {"rule": "self.components['Widget'].priority < 10"} - Rule scoped to a list of integers: {"rule": "self.values.all(value, value >= 0 && value < 100)"} - Rule scoped to a string value: {"rule": "self.startsWith('kube')"}

The `apiVersion`, `kind`, `metadata.name` and `metadata.generateName` are always accessible from the root of the object and from any x-kubernetes-embedded-resource annotated objects. No other metadata properties are accessible.

Unknown data preserved in custom resources via x-kubernetes-preserve-unknown-fields is not accessible in CEL expressions. This includes: - Unknown field values that are preserved by object schemas with x-kubernetes-preserve-unknown-fields. - Object properties where the property schema is of an "unknown type". An "unknown type" is recursively defined as:
  - A schema with no type and x-kubernetes-preserve-unknown-fields set to true
  - An array where the items schema is of an "unknown type"
  - An object where the additionalProperties schema is of an "unknown type"

Only property names of the form `[a-zA-Z_.-/][a-zA-Z0-9_.-/]*` are accessible. Accessible property names are escaped according to the following rules when accessed in the expression: - '__' escapes to 'pass:[__underscores__]' - '.' escapes to 'pass:[__dot__]' - '-' escapes to 'pass:[__dash__]' - '/' escapes to 'pass:[__slash__]' - Property names that exactly match a CEL RESERVED keyword escape to 'pass:[__{keyword}__]'. The keywords are:
	  "true", "false", "null", "in", "as", "break", "const", "continue", "else", "for", "function", "if",
	  "import", "let", "loop", "package", "namespace", "return".
Examples:
  - Rule accessing a property named "namespace": {"rule": "self.pass:[__namespace__] > 0"}
  - Rule accessing a property named "x-prop": {"rule": "self.xpass:[__dash__]prop > 0"}
  - Rule accessing a property named "redact__d": {"rule": "self.redactpass:[__underscores__]d > 0"}

Equality on arrays with x-kubernetes-list-type of 'set' or 'map' ignores element order, i.e. [1, 2] == [2, 1]. Concatenation on arrays with x-kubernetes-list-type use the semantics of the list type:
  - 'set': `X + Y` performs a union where the array positions of all elements in `X` are preserved and
    non-intersecting elements in `Y` are appended, retaining their partial order.
  - 'map': `X + Y` performs a merge where the array positions of all keys in `X` are preserved but the values
    are overwritten by values in `Y` when the key sets of `X` and `Y` intersect. Elements in `Y` with
    non-intersecting keys are appended, retaining their partial order.

|===

[id="io.k8s.apimachinery.pkg.api.resource.Quantity"]
== io.k8s.apimachinery.pkg.api.resource.Quantity schema


Description::
+
--
Quantity is a fixed-point representation of a number. It provides convenient marshaling/unmarshaling in JSON and YAML, in addition to String() and AsInt64() accessors.

The serialization format is:

<quantity>        ::= <signedNumber><suffix>

	(Note that <suffix> may be empty, from the "" case in <decimalSI>.)

<digit>           ::= 0 | 1 | ... | 9 <digits>          ::= <digit> | <digit><digits> <number>          ::= <digits> | <digits>.<digits> | <digits>. | .<digits> <sign>            ::= "+" | "-" <signedNumber>    ::= <number> | <sign><number> <suffix>          ::= <binarySI> | <decimalExponent> | <decimalSI> <binarySI>        ::= Ki | Mi | Gi | Ti | Pi | Ei

	(International System of units; See: http://physics.nist.gov/cuu/Units/binary.html)

<decimalSI>       ::= m | "" | k | M | G | T | P | E

	(Note that 1024 = 1Ki but 1000 = 1k; I didn't choose the capitalization.)

<decimalExponent> ::= "e" <signedNumber> | "E" <signedNumber>

No matter which of the three exponent forms is used, no quantity may represent a number greater than 2^63-1 in magnitude, nor may it have more than 3 decimal places. Numbers larger or more precise will be capped or rounded up. (E.g.: 0.1m will rounded up to 1m.) This may be extended in the future if we require larger or smaller quantities.

When a Quantity is parsed from a string, it will remember the type of suffix it had, and will use the same type again when it is serialized.

Before serializing, Quantity will be put in "canonical form". This means that Exponent/suffix will be adjusted up or down (with a corresponding increase or decrease in Mantissa) such that:

- No precision is lost - No fractional digits will be emitted - The exponent (or suffix) is as large as possible.

The sign will be omitted unless the number is negative.

Examples:

- 1.5 will be serialized as "1500m" - 1.5Gi will be serialized as "1536Mi"

Note that the quantity will NEVER be internally represented by a floating point number. That is the whole point of this exercise.

Non-canonical values will still parse as long as they are well formed, but will be re-emitted in their canonical form. (So always use canonical form, or don't diff.)

This format is intended to make it difficult to use these numbers without writing some sort of special handling code in the hopes that that will cause implementors to also use a fixed point implementation.
--

Type::
  `string`



[id="io.k8s.apimachinery.pkg.apis.meta.v1.Condition"]
== io.k8s.apimachinery.pkg.apis.meta.v1.Condition schema


Description::
+
--
Condition contains details for one aspect of the current state of this API Resource.
--

Type::
  `object`

Required::
  - `type`
  - `status`
  - `lastTransitionTime`
  - `reason`
  - `message`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `lastTransitionTime`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.Time[`Time`]
| lastTransitionTime is the last time the condition transitioned from one status to another. This should be when the underlying condition changed.  If that is not known, then using the time when the API field changed is acceptable.

| `message`
| `string`
| message is a human readable message indicating details about the transition. This may be an empty string.

| `observedGeneration`
| `integer`
| observedGeneration represents the .metadata.generation that the condition was set based upon. For instance, if .metadata.generation is currently 12, but the .status.conditions[x].observedGeneration is 9, the condition is out of date with respect to the current state of the instance.

| `reason`
| `string`
| reason contains a programmatic identifier indicating the reason for the condition's last transition. Producers of specific condition types may define expected values and meanings for this field, and whether the values are considered a guaranteed API. The value should be a CamelCase string. This field may not be empty.

| `status`
| `string`
| status of the condition, one of True, False, Unknown.

| `type`
| `string`
| type of condition in CamelCase or in foo.example.com/CamelCase.

|===

[id="io.k8s.apimachinery.pkg.apis.meta.v1.DeleteOptions"]
== io.k8s.apimachinery.pkg.apis.meta.v1.DeleteOptions schema


Description::
+
--
DeleteOptions may be provided when deleting an API object.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `dryRun`
| `array (string)`
| When present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed

| `gracePeriodSeconds`
| `integer`
| The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `orphanDependents`
| `boolean`
| Deprecated: please use the PropagationPolicy, this field will be deprecated in 1.7. Should the dependent objects be orphaned. If true/false, the "orphan" finalizer will be added to/removed from the object's finalizers list. Either this field or PropagationPolicy may be set, but not both.

| `preconditions`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.Preconditions[`Preconditions`]
| Must be fulfilled before a deletion is carried out. If not possible, a 409 Conflict status will be returned.

| `propagationPolicy`
| `string`
| Whether and how garbage collection will be performed. Either this field or OrphanDependents may be set, but not both. The default policy is decided by the existing finalizer set in the metadata.finalizers and the resource-specific default policy. Acceptable values are: 'Orphan' - orphan the dependents; 'Background' - allow the garbage collector to delete the dependents in the background; 'Foreground' - a cascading policy that deletes all dependents in the foreground.

|===

[id="io.k8s.apimachinery.pkg.apis.meta.v1.FieldsV1"]
== io.k8s.apimachinery.pkg.apis.meta.v1.FieldsV1 schema


Description::
+
--
FieldsV1 stores a set of fields in a data structure like a Trie, in JSON format.

Each key is either a '.' representing the field itself, and will always map to an empty set, or a string representing a sub-field or item. The string will follow one of these four formats: 'f:<name>', where <name> is the name of a field in a struct, or key in a map 'v:<value>', where <value> is the exact json formatted value of a list item 'i:<index>', where <index> is position of a item in a list 'k:<keys>', where <keys> is a map of  a list item's key fields to their unique values If a key maps to an empty Fields value, the field that key represents is part of the set.

The exact format is defined in sigs.k8s.io/structured-merge-diff
--

Type::
  `object`



[id="io.k8s.apimachinery.pkg.apis.meta.v1.LabelSelector"]
== io.k8s.apimachinery.pkg.apis.meta.v1.LabelSelector schema


Description::
+
--
A label selector is a label query over a set of resources. The result of matchLabels and matchExpressions are ANDed. An empty label selector matches all objects. A null label selector matches no objects.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `matchExpressions`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.LabelSelectorRequirement[`array (LabelSelectorRequirement)`]
| matchExpressions is a list of label selector requirements. The requirements are ANDed.

| `matchLabels`
| `object (string)`
| matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.

|===

[id="io.k8s.apimachinery.pkg.apis.meta.v1.LabelSelectorRequirement"]
== io.k8s.apimachinery.pkg.apis.meta.v1.LabelSelectorRequirement schema


Description::
+
--
A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
--

Type::
  `object`

Required::
  - `key`
  - `operator`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `key`
| `string`
| key is the label key that the selector applies to.

| `operator`
| `string`
| operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.

| `values`
| `array (string)`
| values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.

|===

[id="io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta"]
== io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta schema


Description::
+
--
ListMeta describes metadata that synthetic resources must have, including lists and various status objects. A resource may have only one of {ObjectMeta, ListMeta}.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `continue`
| `string`
| continue may be set if the user set a limit on the number of items returned, and indicates that the server has more data available. The value is opaque and may be used to issue another request to the endpoint that served this list to retrieve the next set of available objects. Continuing a consistent list may not be possible if the server configuration has changed or more than a few minutes have passed. The resourceVersion field returned when using this continue value will be identical to the value in the first response, unless you have received this token from an error message.

| `remainingItemCount`
| `integer`
| remainingItemCount is the number of subsequent items in the list which are not included in this list response. If the list request contained label or field selectors, then the number of remaining items is unknown and the field will be left unset and omitted during serialization. If the list is complete (either because it is not chunking or because this is the last chunk), then there are no more remaining items and this field will be left unset and omitted during serialization. Servers older than v1.15 do not set this field. The intended use of the remainingItemCount is *estimating* the size of a collection. Clients should not rely on the remainingItemCount to be set or to be exact.

| `resourceVersion`
| `string`
| String that identifies the server's internal version of this object that can be used by clients to determine when objects have changed. Value must be treated as opaque by clients and passed unmodified back to the server. Populated by the system. Read-only. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency

| `selfLink`
| `string`
| Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.

|===

[id="io.k8s.apimachinery.pkg.apis.meta.v1.ManagedFieldsEntry"]
== io.k8s.apimachinery.pkg.apis.meta.v1.ManagedFieldsEntry schema


Description::
+
--
ManagedFieldsEntry is a workflow-id, a FieldSet and the group version of the resource that the fieldset applies to.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the version of this resource that this field set applies to. The format is "group/version" just like the top-level APIVersion field. It is necessary to track the version of a field set because it cannot be automatically converted.

| `fieldsType`
| `string`
| FieldsType is the discriminator for the different fields format and version. There is currently only one possible value: "FieldsV1"

| `fieldsV1`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.FieldsV1[`FieldsV1`]
| FieldsV1 holds the first JSON version format as described in the "FieldsV1" type.

| `manager`
| `string`
| Manager is an identifier of the workflow managing these fields.

| `operation`
| `string`
| Operation is the type of operation which lead to this ManagedFieldsEntry being created. The only valid values for this field are 'Apply' and 'Update'.

| `subresource`
| `string`
| Subresource is the name of the subresource used to update that object, or empty string if the object was updated through the main resource. The value of this field is used to distinguish between managers, even if they share the same name. For example, a status update will be distinct from a regular update using the same manager name. Note that the APIVersion field is not related to the Subresource field and it always corresponds to the version of the main resource.

| `time`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.Time[`Time`]
| Time is the timestamp of when the ManagedFields entry was added. The timestamp will also be updated if a field is added, the manager changes any of the owned fields value or removes a field. The timestamp does not update when a field is removed from the entry because another manager took it over.

|===

[id="io.k8s.apimachinery.pkg.apis.meta.v1.MicroTime"]
== io.k8s.apimachinery.pkg.apis.meta.v1.MicroTime schema


Description::
+
--
MicroTime is version of Time with microsecond level precision.
--

Type::
  `string`



[id="io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta"]
== io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta schema


Description::
+
--
ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `annotations`
| `object (string)`
| Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations

| `creationTimestamp`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.Time[`Time`]
| CreationTimestamp is a timestamp representing the server time when this object was created. It is not guaranteed to be set in happens-before order across separate operations. Clients may not set this value. It is represented in RFC3339 form and is in UTC.

Populated by the system. Read-only. Null for lists. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

| `deletionGracePeriodSeconds`
| `integer`
| Number of seconds allowed for this object to gracefully terminate before it will be removed from the system. Only set when deletionTimestamp is also set. May only be shortened. Read-only.

| `deletionTimestamp`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.Time[`Time`]
| DeletionTimestamp is RFC 3339 date and time at which this resource will be deleted. This field is set by the server when a graceful deletion is requested by the user, and is not directly settable by a client. The resource is expected to be deleted (no longer visible from resource lists, and not reachable by name) after the time in this field, once the finalizers list is empty. As long as the finalizers list contains items, deletion is blocked. Once the deletionTimestamp is set, this value may not be unset or be set further into the future, although it may be shortened or the resource may be deleted prior to this time. For example, a user may request that a pod is deleted in 30 seconds. The Kubelet will react by sending a graceful termination signal to the containers in the pod. After that 30 seconds, the Kubelet will send a hard termination signal (SIGKILL) to the container and after cleanup, remove the pod from the API. In the presence of network partitions, this object may still exist after this timestamp, until an administrator or automated process can determine the resource is fully terminated. If not set, graceful deletion of the object has not been requested.

Populated by the system when a graceful deletion is requested. Read-only. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

| `finalizers`
| `array (string)`
| Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed. Finalizers may be processed and removed in any order.  Order is NOT enforced because it introduces significant risk of stuck finalizers. finalizers is a shared field, any actor with permission can reorder it. If the finalizer list is processed in order, then this can lead to a situation in which the component responsible for the first finalizer in the list is waiting for a signal (field value, external system, or other) produced by a component responsible for a finalizer later in the list, resulting in a deadlock. Without enforced ordering finalizers are free to order amongst themselves and are not vulnerable to ordering changes in the list.

| `generateName`
| `string`
| GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.

If this field is specified and the generated name exists, the server will return a 409.

Applied only if Name is not specified. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#idempotency

| `generation`
| `integer`
| A sequence number representing a specific generation of the desired state. Populated by the system. Read-only.

| `labels`
| `object (string)`
| Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels

| `managedFields`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ManagedFieldsEntry[`array (ManagedFieldsEntry)`]
| ManagedFields maps workflow-id and version to the set of fields that are managed by that workflow. This is mostly for internal housekeeping, and users typically shouldn't need to set or understand this field. A workflow can be the user's name, a controller's name, or the name of a specific apply path like "ci-cd". The set of fields is always in the version that the workflow used when modifying the object.

| `name`
| `string`
| Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names

| `namespace`
| `string`
| Namespace defines the space within which each name must be unique. An empty namespace is equivalent to the "default" namespace, but "default" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.

Must be a DNS_LABEL. Cannot be updated. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces

| `ownerReferences`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.OwnerReference[`array (OwnerReference)`]
| List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller.

| `resourceVersion`
| `string`
| An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed. May be used for optimistic concurrency, change detection, and the watch operation on a resource or set of resources. Clients must treat these values as opaque and passed unmodified back to the server. They may only be valid for a particular resource or set of resources.

Populated by the system. Read-only. Value must be treated as opaque by clients and . More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency

| `selfLink`
| `string`
| Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.

| `uid`
| `string`
| UID is the unique in time and space value for this object. It is typically generated by the server on successful creation of a resource and is not allowed to change on PUT operations.

Populated by the system. Read-only. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids

|===

[id="io.k8s.apimachinery.pkg.apis.meta.v1.OwnerReference"]
== io.k8s.apimachinery.pkg.apis.meta.v1.OwnerReference schema


Description::
+
--
OwnerReference contains enough information to let you identify an owning object. An owning object must be in the same namespace as the dependent, or be cluster-scoped, so there is no namespace field.
--

Type::
  `object`

Required::
  - `apiVersion`
  - `kind`
  - `name`
  - `uid`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| API version of the referent.

| `blockOwnerDeletion`
| `boolean`
| If true, AND if the owner has the "foregroundDeletion" finalizer, then the owner cannot be deleted from the key-value store until this reference is removed. See https://kubernetes.io/docs/concepts/architecture/garbage-collection/#foreground-deletion for how the garbage collector interacts with this field and enforces the foreground deletion. Defaults to false. To set this field, a user needs "delete" permission of the owner, otherwise 422 (Unprocessable Entity) will be returned.

| `controller`
| `boolean`
| If true, this reference points to the managing controller.

| `kind`
| `string`
| Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `name`
| `string`
| Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names

| `uid`
| `string`
| UID of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids

|===

[id="io.k8s.apimachinery.pkg.apis.meta.v1.Patch"]
== io.k8s.apimachinery.pkg.apis.meta.v1.Patch schema


Description::
+
--
Patch is provided to give a concrete name and type to the Kubernetes PATCH request body.
--

Type::
  `object`



[id="io.k8s.apimachinery.pkg.apis.meta.v1.Preconditions"]
== io.k8s.apimachinery.pkg.apis.meta.v1.Preconditions schema


Description::
+
--
Preconditions must be fulfilled before an operation (update, delete, etc.) is carried out.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `resourceVersion`
| `string`
| Specifies the target ResourceVersion

| `uid`
| `string`
| Specifies the target UID.

|===

[id="io.k8s.apimachinery.pkg.apis.meta.v1.Status"]
== io.k8s.apimachinery.pkg.apis.meta.v1.Status schema


Description::
+
--
Status is a return value for calls that don't return other objects.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `code`
| `integer`
| Suggested HTTP return code for this status, 0 if not set.

| `details`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.StatusDetails[`StatusDetails`]
| Extended data associated with the reason.  Each reason may define its own extended details. This field is optional and the data returned is not guaranteed to conform to any schema except that defined by the reason type.

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `message`
| `string`
| A human-readable description of the status of this operation.

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `reason`
| `string`
| A machine-readable description of why this operation is in the "Failure" status. If this value is empty there is no information available. A Reason clarifies an HTTP status code but does not override it.

| `status`
| `string`
| Status of the operation. One of: "Success" or "Failure". More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status

|===

[id="io.k8s.apimachinery.pkg.apis.meta.v1.StatusCause"]
== io.k8s.apimachinery.pkg.apis.meta.v1.StatusCause schema


Description::
+
--
StatusCause provides more information about an api.Status failure, including cases when multiple errors are encountered.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `field`
| `string`
| The field of the resource that has caused this error, as named by its JSON serialization. May include dot and postfix notation for nested attributes. Arrays are zero-indexed.  Fields may appear more than once in an array of causes due to fields having multiple errors. Optional.

Examples:
  "name" - the field "name" on the current resource
  "items[0].name" - the field "name" on the first array entry in "items"

| `message`
| `string`
| A human-readable description of the cause of the error.  This field may be presented as-is to a reader.

| `reason`
| `string`
| A machine-readable description of the cause of the error. If this value is empty there is no information available.

|===

[id="io.k8s.apimachinery.pkg.apis.meta.v1.StatusDetails"]
== io.k8s.apimachinery.pkg.apis.meta.v1.StatusDetails schema


Description::
+
--
StatusDetails is a set of additional properties that MAY be set by the server to provide additional information about a response. The Reason field of a Status object defines what attributes will be set. Clients must ignore fields that do not match the defined type of each attribute, and should assume that any attribute may be empty, invalid, or under defined.
--

Type::
  `object`


[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `causes`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.StatusCause[`array (StatusCause)`]
| The Causes array includes more details associated with the StatusReason failure. Not all StatusReasons may provide detailed causes.

| `group`
| `string`
| The group attribute of the resource associated with the status StatusReason.

| `kind`
| `string`
| The kind attribute of the resource associated with the status StatusReason. On some operations may differ from the requested resource Kind. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `name`
| `string`
| The name attribute of the resource associated with the status StatusReason (when there is a single name which can be described).

| `retryAfterSeconds`
| `integer`
| If specified, the time in seconds before the operation should be retried. Some errors may indicate the client must take an alternate action - for those errors this field may indicate how long to wait before taking the alternate action.

| `uid`
| `string`
| UID of the resource. (when there is a single resource which can be described). More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids

|===

[id="io.k8s.apimachinery.pkg.apis.meta.v1.Time"]
== io.k8s.apimachinery.pkg.apis.meta.v1.Time schema


Description::
+
--
Time is a wrapper around time.Time which supports correct marshaling to YAML and JSON.  Wrappers are provided for many of the factory methods that the time package offers.
--

Type::
  `string`



[id="io.k8s.apimachinery.pkg.apis.meta.v1.WatchEvent"]
== io.k8s.apimachinery.pkg.apis.meta.v1.WatchEvent schema


Description::
+
--
Event represents a single event to a watched resource.
--

Type::
  `object`

Required::
  - `type`
  - `object`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `object`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.runtime.RawExtension[`RawExtension`]
| Object is:
 * If Type is Added or Modified: the new state of the object.
 * If Type is Deleted: the state of the object immediately before deletion.
 * If Type is Error: *Status is recommended; other types may make sense
   depending on context.

| `type`
| `string`
|

|===

[id="io.k8s.apimachinery.pkg.runtime.RawExtension"]
== io.k8s.apimachinery.pkg.runtime.RawExtension schema


Description::
+
--
RawExtension is used to hold extensions in external versions.

To use this, make a field which has RawExtension as its type in your external, versioned struct, and Object in your internal struct. You also need to register your various plugin types.

// Internal package:

	type MyAPIObject struct {
		runtime.TypeMeta `json:",inline"`
		MyPlugin runtime.Object `json:"myPlugin"`
	}

	type PluginA struct {
		AOption string `json:"aOption"`
	}

// External package:

	type MyAPIObject struct {
		runtime.TypeMeta `json:",inline"`
		MyPlugin runtime.RawExtension `json:"myPlugin"`
	}

	type PluginA struct {
		AOption string `json:"aOption"`
	}

// On the wire, the JSON will look something like this:

	{
		"kind":"MyAPIObject",
		"apiVersion":"v1",
		"myPlugin": {
			"kind":"PluginA",
			"aOption":"foo",
		},
	}

So what happens? Decode first uses json or yaml to unmarshal the serialized data into your external MyAPIObject. That causes the raw JSON to be stored, but not unpacked. The next step is to copy (using pkg/conversion) into the internal struct. The runtime package's DefaultScheme has conversion functions installed which will unpack the JSON stored in RawExtension, turning it into the correct object type, and storing it in the Object. (TODO: In the case where the object is of an unknown type, a runtime.Unknown object will be created and stored.)
--

Type::
  `object`



[id="io.k8s.apimachinery.pkg.util.intstr.IntOrString"]
== io.k8s.apimachinery.pkg.util.intstr.IntOrString schema


Description::
+
--
IntOrString is a type that can hold an int32 or a string.  When used in JSON or YAML marshalling and unmarshalling, it produces or consumes the inner type.  This allows you to have, for example, a JSON field that can accept a name or number.
--

Type::
  `string`



[id="io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIServiceList"]
== io.k8s.kube-aggregator.pkg.apis.apiregistration.v1.APIServiceList schema


Description::
+
--
APIServiceList is a list of APIService objects.
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../api_registration_apis/apiservice-apiregistration-k8s-io-v1.adoc#apiservice-apiregistration-k8s-io-v1[`array (APIService)`]
| Items is the list of APIService

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#metadata

|===

[id="io.k8s.migration.v1alpha1.StorageVersionMigrationList"]
== io.k8s.migration.v1alpha1.StorageVersionMigrationList schema


Description::
+
--
StorageVersionMigrationList is a list of StorageVersionMigration
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../storage_version_migration_apis/storageversionmigration-migration-k8s-io-v1alpha1.adoc#storageversionmigration-migration-k8s-io-v1alpha1[`array (StorageVersionMigration)`]
| List of storageversionmigrations. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.storage.snapshot.v1.VolumeSnapshotClassList"]
== io.k8s.storage.snapshot.v1.VolumeSnapshotClassList schema


Description::
+
--
VolumeSnapshotClassList is a list of VolumeSnapshotClass
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../snapshot_apis/volumesnapshotclass-snapshot-storage-k8s-io-v1.adoc#volumesnapshotclass-snapshot-storage-k8s-io-v1[`array (VolumeSnapshotClass)`]
| List of volumesnapshotclasses. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.storage.snapshot.v1.VolumeSnapshotContentList"]
== io.k8s.storage.snapshot.v1.VolumeSnapshotContentList schema


Description::
+
--
VolumeSnapshotContentList is a list of VolumeSnapshotContent
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../snapshot_apis/volumesnapshotcontent-snapshot-storage-k8s-io-v1.adoc#volumesnapshotcontent-snapshot-storage-k8s-io-v1[`array (VolumeSnapshotContent)`]
| List of volumesnapshotcontents. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.k8s.storage.snapshot.v1.VolumeSnapshotList"]
== io.k8s.storage.snapshot.v1.VolumeSnapshotList schema


Description::
+
--
VolumeSnapshotList is a list of VolumeSnapshot
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../snapshot_apis/volumesnapshot-snapshot-storage-k8s-io-v1.adoc#volumesnapshot-snapshot-storage-k8s-io-v1[`array (VolumeSnapshot)`]
| List of volumesnapshots. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.openshift.internal.security.v1.RangeAllocationList"]
== io.openshift.internal.security.v1.RangeAllocationList schema


Description::
+
--
RangeAllocationList is a list of RangeAllocation
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../security_internal_apis/rangeallocation-security-internal-openshift-io-v1.adoc#rangeallocation-security-internal-openshift-io-v1[`array (RangeAllocation)`]
| List of rangeallocations. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.openshift.route.v1.RouteList"]
== io.openshift.route.v1.RouteList schema


Description::
+
--
RouteList is a list of Route
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../network_apis/route-route-openshift-io-v1.adoc#route-route-openshift-io-v1[`array (Route)`]
| List of routes. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.openshift.security.v1.SecurityContextConstraintsList"]
== io.openshift.security.v1.SecurityContextConstraintsList schema


Description::
+
--
SecurityContextConstraintsList is a list of SecurityContextConstraints
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../security_apis/securitycontextconstraints-security-openshift-io-v1.adoc#securitycontextconstraints-security-openshift-io-v1[`array (SecurityContextConstraints)`]
| List of securitycontextconstraints. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

[id="io.topolvm.v1.LogicalVolumeList"]
== io.topolvm.v1.LogicalVolumeList schema


Description::
+
--
LogicalVolumeList is a list of LogicalVolume
--

Type::
  `object`

Required::
  - `items`

[discrete]
=== Schema

[cols="1,1,1",options="header"]
|===
| Property | Type | Description

| `apiVersion`
| `string`
| APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

| `items`
| xref:../topolvm_apis/logicalvolume-topolvm-io-v1.adoc#logicalvolume-topolvm-io-v1[`array (LogicalVolume)`]
| List of logicalvolumes. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md

| `kind`
| `string`
| Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

| `metadata`
| xref:../objects/index.adoc#io.k8s.apimachinery.pkg.apis.meta.v1.ListMeta[`ListMeta`]
| Standard list metadata. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

|===

